searchData={"items":[{"type":"module","title":"Appsignal","doc":"AppSignal for Elixir. Follow the [installation\nguide](https://docs.appsignal.com/elixir/installation.html) to install\nAppSignal into your Elixir app.\n\nThis module contains the main AppSignal OTP application, as well as a few\nhelper functions for sending metrics to AppSignal.","ref":"Appsignal.html"},{"type":"function","title":"Appsignal.add_distribution_value/3","doc":"Add a value to a distribution\n\nUse this to collect multiple data points that will be merged into a graph.","ref":"Appsignal.html#add_distribution_value/3"},{"type":"function","title":"Appsignal.heartbeat/1","doc":"","ref":"Appsignal.html#heartbeat/1"},{"type":"function","title":"Appsignal.heartbeat/2","doc":"","ref":"Appsignal.html#heartbeat/2"},{"type":"function","title":"Appsignal.increment_counter/3","doc":"Increment a counter of a metric.","ref":"Appsignal.html#increment_counter/3"},{"type":"function","title":"Appsignal.instrument/1","doc":"","ref":"Appsignal.html#instrument/1"},{"type":"function","title":"Appsignal.instrument/2","doc":"","ref":"Appsignal.html#instrument/2"},{"type":"function","title":"Appsignal.instrument/3","doc":"","ref":"Appsignal.html#instrument/3"},{"type":"function","title":"Appsignal.send_error/2","doc":"","ref":"Appsignal.html#send_error/2"},{"type":"function","title":"Appsignal.send_error/3","doc":"","ref":"Appsignal.html#send_error/3"},{"type":"function","title":"Appsignal.send_error/4","doc":"","ref":"Appsignal.html#send_error/4"},{"type":"function","title":"Appsignal.set_error/2","doc":"","ref":"Appsignal.html#set_error/2"},{"type":"function","title":"Appsignal.set_error/3","doc":"","ref":"Appsignal.html#set_error/3"},{"type":"function","title":"Appsignal.set_gauge/3","doc":"Set a gauge for a measurement of a metric.","ref":"Appsignal.html#set_gauge/3"},{"type":"module","title":"Appsignal.Ecto","doc":"","ref":"Appsignal.Ecto.html"},{"type":"function","title":"Appsignal.Ecto.attach/0","doc":"Attaches `Appsignal.Ecto` to the Ecto telemetry channel configured in the\napplication's configuration.","ref":"Appsignal.Ecto.html#attach/0"},{"type":"function","title":"Appsignal.Ecto.attach/2","doc":"Attaches `Appsignal.Ecto` to the Ecto telemetry channel based on the passed\n`otp_app` and `repo`.","ref":"Appsignal.Ecto.html#attach/2"},{"type":"module","title":"Appsignal.Ecto.Repo","doc":"","ref":"Appsignal.Ecto.Repo.html"},{"type":"function","title":"Appsignal.Ecto.Repo.default_options/1","doc":"","ref":"Appsignal.Ecto.Repo.html#default_options/1"},{"type":"module","title":"Appsignal.Heartbeat","doc":"","ref":"Appsignal.Heartbeat.html"},{"type":"function","title":"Appsignal.Heartbeat.finish/1","doc":"","ref":"Appsignal.Heartbeat.html#finish/1"},{"type":"function","title":"Appsignal.Heartbeat.heartbeat/1","doc":"","ref":"Appsignal.Heartbeat.html#heartbeat/1"},{"type":"function","title":"Appsignal.Heartbeat.heartbeat/2","doc":"","ref":"Appsignal.Heartbeat.html#heartbeat/2"},{"type":"function","title":"Appsignal.Heartbeat.new/1","doc":"","ref":"Appsignal.Heartbeat.html#new/1"},{"type":"function","title":"Appsignal.Heartbeat.start/1","doc":"","ref":"Appsignal.Heartbeat.html#start/1"},{"type":"type","title":"Appsignal.Heartbeat.t/0","doc":"","ref":"Appsignal.Heartbeat.html#t:t/0"},{"type":"module","title":"Appsignal.Heartbeat.Event","doc":"","ref":"Appsignal.Heartbeat.Event.html"},{"type":"function","title":"Appsignal.Heartbeat.Event.new/2","doc":"","ref":"Appsignal.Heartbeat.Event.html#new/2"},{"type":"type","title":"Appsignal.Heartbeat.Event.kind/0","doc":"","ref":"Appsignal.Heartbeat.Event.html#t:kind/0"},{"type":"type","title":"Appsignal.Heartbeat.Event.t/0","doc":"","ref":"Appsignal.Heartbeat.Event.html#t:t/0"},{"type":"module","title":"Appsignal.Instrumentation","doc":"","ref":"Appsignal.Instrumentation.html"},{"type":"function","title":"Appsignal.Instrumentation.instrument/2","doc":"Instrument a function.\n\n    def call do\n      Appsignal.instrument(\"foo.bar\", fn ->\n        :timer.sleep(1000)\n      end)\n    end\n\nWhen passing a function that takes an argument, the function is called with\nthe created span to allow adding extra information.\n\n    def call(params) do\n      Appsignal.instrument(\"foo.bar\", fn span ->\n        Appsignal.Span.set_sample_data(span, \"params\", params)\n        :timer.sleep(1000)\n      end)\n    end","ref":"Appsignal.Instrumentation.html#instrument/2"},{"type":"function","title":"Appsignal.Instrumentation.instrument/3","doc":"Instrument a function, and set the `\"appsignal:category\"` attribute to the\nvalue passed as the `category` argument.","ref":"Appsignal.Instrumentation.html#instrument/3"},{"type":"function","title":"Appsignal.Instrumentation.instrument/4","doc":"","ref":"Appsignal.Instrumentation.html#instrument/4"},{"type":"function","title":"Appsignal.Instrumentation.send_error/2","doc":"Send an error in a newly created `Appsignal.Span`.","ref":"Appsignal.Instrumentation.html#send_error/2"},{"type":"function","title":"Appsignal.Instrumentation.send_error/3","doc":"Send an error in a newly created `Appsignal.Span`. Calls the passed function\nwith the created `Appsignal.Span` before closing it.","ref":"Appsignal.Instrumentation.html#send_error/3"},{"type":"function","title":"Appsignal.Instrumentation.send_error/4","doc":"","ref":"Appsignal.Instrumentation.html#send_error/4"},{"type":"function","title":"Appsignal.Instrumentation.set_error/2","doc":"Set an error in the current root span.","ref":"Appsignal.Instrumentation.html#set_error/2"},{"type":"function","title":"Appsignal.Instrumentation.set_error/3","doc":"Set an error in the current root span by passing a `kind` and `reason`.","ref":"Appsignal.Instrumentation.html#set_error/3"},{"type":"module","title":"Appsignal.Instrumentation.Helpers","doc":"","ref":"Appsignal.Instrumentation.Helpers.html"},{"type":"function","title":"Appsignal.Instrumentation.Helpers.instrument/1","doc":"","ref":"Appsignal.Instrumentation.Helpers.html#instrument/1"},{"type":"function","title":"Appsignal.Instrumentation.Helpers.instrument/2","doc":"","ref":"Appsignal.Instrumentation.Helpers.html#instrument/2"},{"type":"function","title":"Appsignal.Instrumentation.Helpers.instrument/3","doc":"","ref":"Appsignal.Instrumentation.Helpers.html#instrument/3"},{"type":"function","title":"Appsignal.Instrumentation.Helpers.instrument/4","doc":"","ref":"Appsignal.Instrumentation.Helpers.html#instrument/4"},{"type":"module","title":"Appsignal.IntegrationLogger","doc":"","ref":"Appsignal.IntegrationLogger.html"},{"type":"function","title":"Appsignal.IntegrationLogger.debug/1","doc":"","ref":"Appsignal.IntegrationLogger.html#debug/1"},{"type":"function","title":"Appsignal.IntegrationLogger.error/2","doc":"","ref":"Appsignal.IntegrationLogger.html#error/2"},{"type":"function","title":"Appsignal.IntegrationLogger.info/1","doc":"","ref":"Appsignal.IntegrationLogger.html#info/1"},{"type":"function","title":"Appsignal.IntegrationLogger.trace/1","doc":"","ref":"Appsignal.IntegrationLogger.html#trace/1"},{"type":"function","title":"Appsignal.IntegrationLogger.warn/2","doc":"","ref":"Appsignal.IntegrationLogger.html#warn/2"},{"type":"type","title":"Appsignal.IntegrationLogger.device/0","doc":"","ref":"Appsignal.IntegrationLogger.html#t:device/0"},{"type":"type","title":"Appsignal.IntegrationLogger.log_level/0","doc":"","ref":"Appsignal.IntegrationLogger.html#t:log_level/0"},{"type":"module","title":"Appsignal.Logger","doc":"","ref":"Appsignal.Logger.html"},{"type":"function","title":"Appsignal.Logger.alert/3","doc":"","ref":"Appsignal.Logger.html#alert/3"},{"type":"function","title":"Appsignal.Logger.critical/3","doc":"","ref":"Appsignal.Logger.html#critical/3"},{"type":"function","title":"Appsignal.Logger.debug/3","doc":"","ref":"Appsignal.Logger.html#debug/3"},{"type":"function","title":"Appsignal.Logger.emergency/3","doc":"","ref":"Appsignal.Logger.html#emergency/3"},{"type":"function","title":"Appsignal.Logger.error/3","doc":"","ref":"Appsignal.Logger.html#error/3"},{"type":"function","title":"Appsignal.Logger.info/3","doc":"","ref":"Appsignal.Logger.html#info/3"},{"type":"function","title":"Appsignal.Logger.log/5","doc":"","ref":"Appsignal.Logger.html#log/5"},{"type":"function","title":"Appsignal.Logger.notice/3","doc":"","ref":"Appsignal.Logger.html#notice/3"},{"type":"function","title":"Appsignal.Logger.warning/3","doc":"","ref":"Appsignal.Logger.html#warning/3"},{"type":"type","title":"Appsignal.Logger.format/0","doc":"","ref":"Appsignal.Logger.html#t:format/0"},{"type":"type","title":"Appsignal.Logger.log_level/0","doc":"","ref":"Appsignal.Logger.html#t:log_level/0"},{"type":"module","title":"Appsignal.Logger.Backend","doc":"","ref":"Appsignal.Logger.Backend.html"},{"type":"function","title":"Appsignal.Logger.Backend.handle_call/2","doc":"","ref":"Appsignal.Logger.Backend.html#handle_call/2"},{"type":"function","title":"Appsignal.Logger.Backend.handle_event/2","doc":"","ref":"Appsignal.Logger.Backend.html#handle_event/2"},{"type":"function","title":"Appsignal.Logger.Backend.init/1","doc":"","ref":"Appsignal.Logger.Backend.html#init/1"},{"type":"module","title":"Appsignal.Logger.Handler","doc":"","ref":"Appsignal.Logger.Handler.html"},{"type":"function","title":"Appsignal.Logger.Handler.add/2","doc":"","ref":"Appsignal.Logger.Handler.html#add/2"},{"type":"function","title":"Appsignal.Logger.Handler.log/2","doc":"","ref":"Appsignal.Logger.Handler.html#log/2"},{"type":"function","title":"Appsignal.Logger.Handler.remove/0","doc":"","ref":"Appsignal.Logger.Handler.html#remove/0"},{"type":"protocol","title":"Appsignal.Metadata","doc":"","ref":"Appsignal.Metadata.html"},{"type":"function","title":"Appsignal.Metadata.category/1","doc":"","ref":"Appsignal.Metadata.html#category/1"},{"type":"function","title":"Appsignal.Metadata.metadata/1","doc":"","ref":"Appsignal.Metadata.html#metadata/1"},{"type":"function","title":"Appsignal.Metadata.name/1","doc":"","ref":"Appsignal.Metadata.html#name/1"},{"type":"function","title":"Appsignal.Metadata.params/1","doc":"","ref":"Appsignal.Metadata.html#params/1"},{"type":"function","title":"Appsignal.Metadata.session/1","doc":"","ref":"Appsignal.Metadata.html#session/1"},{"type":"type","title":"Appsignal.Metadata.t/0","doc":"All the types that implement this protocol.","ref":"Appsignal.Metadata.html#t:t/0"},{"type":"module","title":"Appsignal.Span","doc":"","ref":"Appsignal.Span.html"},{"type":"function","title":"Appsignal.Span.add_error/3","doc":"Add an error to an `Appsignal.Span` by passing an exception from a `rescue`\nblock, and a stack trace.","ref":"Appsignal.Span.html#add_error/3"},{"type":"function","title":"Example - Appsignal.Span.add_error/3","doc":"span = Appsignal.Tracer.root_span()\n\n    try\n      raise \"Exception!\"\n    rescue\n      exception ->\n        Appsignal.Span.add_error(span, exception, __STACKTRACE__)\n    end","ref":"Appsignal.Span.html#add_error/3-example"},{"type":"function","title":"Appsignal.Span.add_error/4","doc":"Add an error to an `Appsignal.Span` by passing a `kind` and `reason` from a\n`catch` block, and a stack trace.","ref":"Appsignal.Span.html#add_error/4"},{"type":"function","title":"Example - Appsignal.Span.add_error/4","doc":"span = Appsignal.Tracer.root_span()\n\n    try\n      raise \"Exception!\"\n    catch\n      kind, reason ->\n        Appsignal.Span.add_error(span, kind, reason, __STACKTRACE__)\n    end","ref":"Appsignal.Span.html#add_error/4-example"},{"type":"function","title":"Appsignal.Span.close/1","doc":"Close an `Appsignal.Span`.","ref":"Appsignal.Span.html#close/1"},{"type":"function","title":"Example - Appsignal.Span.close/1","doc":"Appsignal.Tracer.root_span()\n    |> Span.close()","ref":"Appsignal.Span.html#close/1-example"},{"type":"function","title":"Appsignal.Span.close/2","doc":"Close an `Appsignal.Span` with an explicit end time.","ref":"Appsignal.Span.html#close/2"},{"type":"function","title":"Example - Appsignal.Span.close/2","doc":"Appsignal.Tracer.root_span()\n    |> Span.close(span, :os.system_time())","ref":"Appsignal.Span.html#close/2-example"},{"type":"function","title":"Appsignal.Span.create_child/2","doc":"Create a child `Appsignal.Span`.","ref":"Appsignal.Span.html#create_child/2"},{"type":"function","title":"Example - Appsignal.Span.create_child/2","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.create_child(self())","ref":"Appsignal.Span.html#create_child/2-example"},{"type":"function","title":"Appsignal.Span.create_child/3","doc":"Create a child `Appsignal.Span` with an explicit start time.","ref":"Appsignal.Span.html#create_child/3"},{"type":"function","title":"Example - Appsignal.Span.create_child/3","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.create_child(self(), :os.system_time())","ref":"Appsignal.Span.html#create_child/3-example"},{"type":"function","title":"Appsignal.Span.create_root/2","doc":"Create a root `Appsignal.Span` with a namespace and a pid.\n\nFor a description of namespaces, see `set_namespace/2`.","ref":"Appsignal.Span.html#create_root/2"},{"type":"function","title":"Example - Appsignal.Span.create_root/2","doc":"Appsignal.Span.create_root(\"http_request\", self())","ref":"Appsignal.Span.html#create_root/2-example"},{"type":"function","title":"Appsignal.Span.create_root/3","doc":"Create a root `Appsignal.Span` with a namespace, a pid and an explicit start time.\n\nFor a description of namespaces, see `set_namespace/2`.","ref":"Appsignal.Span.html#create_root/3"},{"type":"function","title":"Example - Appsignal.Span.create_root/3","doc":"Appsignal.Span.create_root(\"http_request\", self(), :os.system_time())","ref":"Appsignal.Span.html#create_root/3-example"},{"type":"function","title":"Appsignal.Span.set_attribute/3","doc":"Sets an `Appsignal.Span` attribute.","ref":"Appsignal.Span.html#set_attribute/3"},{"type":"function","title":"Example - Appsignal.Span.set_attribute/3","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.set_attribute(\"appsignal:category\", \"query.ecto\")","ref":"Appsignal.Span.html#set_attribute/3-example"},{"type":"function","title":"Appsignal.Span.set_name/2","doc":"Sets an `Appsignal.Span`'s name.","ref":"Appsignal.Span.html#set_name/2"},{"type":"function","title":"Example - Appsignal.Span.set_name/2","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.set_name(\"PageController#index\")","ref":"Appsignal.Span.html#set_name/2-example"},{"type":"function","title":"Appsignal.Span.set_namespace/2","doc":"Sets an `Appsignal.Span`'s namespace.  The namespace is `\"http_request\"` or\n`\"background_job'` to add the span to the \"web\" and \"background\" namespaces\nrespectively. Passing another string creates a custom namespace to store the\n`Appsignal.Span`'s samples in.","ref":"Appsignal.Span.html#set_namespace/2"},{"type":"function","title":"Example - Appsignal.Span.set_namespace/2","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.set_namespace(\"http_request\")","ref":"Appsignal.Span.html#set_namespace/2-example"},{"type":"function","title":"Appsignal.Span.set_sample_data/3","doc":"Sets sample data for an `Appsignal.Span`.","ref":"Appsignal.Span.html#set_sample_data/3"},{"type":"function","title":"Example - Appsignal.Span.set_sample_data/3","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.set_sample_data(\"environment\", %{\"method\" => \"GET\"})","ref":"Appsignal.Span.html#set_sample_data/3-example"},{"type":"function","title":"Appsignal.Span.set_sample_data_if_nil/3","doc":"Sets sample data for an `Appsignal.Span`, unless it has already been set.","ref":"Appsignal.Span.html#set_sample_data_if_nil/3"},{"type":"function","title":"Example - Appsignal.Span.set_sample_data_if_nil/3","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.set_sample_data_if_nil(\"environment\", %{\"method\" => \"GET\"})","ref":"Appsignal.Span.html#set_sample_data_if_nil/3-example"},{"type":"function","title":"Appsignal.Span.set_sql/2","doc":"Sets the `\"appsignal:body\"` attribute with an SQL query string.","ref":"Appsignal.Span.html#set_sql/2"},{"type":"function","title":"Example - Appsignal.Span.set_sql/2","doc":"Appsignal.Tracer.root_span()\n    |> Appsignal.Span.set_sql(\"SELECT * FROM users\")","ref":"Appsignal.Span.html#set_sql/2-example"},{"type":"type","title":"Appsignal.Span.t/0","doc":"","ref":"Appsignal.Span.html#t:t/0"},{"type":"module","title":"Appsignal.Tracer","doc":"","ref":"Appsignal.Tracer.html"},{"type":"function","title":"Appsignal.Tracer.close_span/1","doc":"Closes a span and deregisters it.","ref":"Appsignal.Tracer.html#close_span/1"},{"type":"function","title":"Example - Appsignal.Tracer.close_span/1","doc":"Appsignal.Tracer.current_span()\n    |> Appsignal.Tracer.close_span()","ref":"Appsignal.Tracer.html#close_span/1-example"},{"type":"function","title":"Appsignal.Tracer.close_span/2","doc":"Closes a span and deregisters it. Takes an options list, which currently only\naccepts a `List` with an `:end_time` integer.","ref":"Appsignal.Tracer.html#close_span/2"},{"type":"function","title":"Example - Appsignal.Tracer.close_span/2","doc":"Appsignal.Tracer.current_span()\n    |> Appsignal.Tracer.close_span(end_time: :os.system_time())","ref":"Appsignal.Tracer.html#close_span/2-example"},{"type":"function","title":"Appsignal.Tracer.create_span/1","doc":"Creates a new root span.","ref":"Appsignal.Tracer.html#create_span/1"},{"type":"function","title":"Example - Appsignal.Tracer.create_span/1","doc":"Appsignal.Tracer.create_span(\"http_request\")","ref":"Appsignal.Tracer.html#create_span/1-example"},{"type":"function","title":"Appsignal.Tracer.create_span/2","doc":"Creates a new child span.","ref":"Appsignal.Tracer.html#create_span/2"},{"type":"function","title":"Example - Appsignal.Tracer.create_span/2","doc":"parent = Appsignal.Tracer.current_span()\n\n    Appsignal.Tracer.create_span(\"http_request\", parent)","ref":"Appsignal.Tracer.html#create_span/2-example"},{"type":"function","title":"Appsignal.Tracer.create_span/3","doc":"Creates a new span, with an optional parent or pid.","ref":"Appsignal.Tracer.html#create_span/3"},{"type":"function","title":"Example - Appsignal.Tracer.create_span/3","doc":"parent = Appsignal.Tracer.current_span()\n\n    Appsignal.Tracer.create_span(\"http_request\", parent, [start_time: :os.system_time(), pid: self()])","ref":"Appsignal.Tracer.html#create_span/3-example"},{"type":"function","title":"Appsignal.Tracer.current_span/0","doc":"Returns the current span in the current process.","ref":"Appsignal.Tracer.html#current_span/0"},{"type":"function","title":"Appsignal.Tracer.current_span/1","doc":"Returns the current span in the passed pid's process.","ref":"Appsignal.Tracer.html#current_span/1"},{"type":"function","title":"Appsignal.Tracer.custom_on_create_fun/1","doc":"This function can be defined by the user and will be executed on the\ncreation of the span after create_span/3 is executed. It can be used to add\ncustom_data to the span.\n\nExample in your own application:\n```ex\ndefmodule MyApp.Appsignal do\n  def custom_on_create_fun(span) do\n    Appsignal.Span.set_sample_data(span, \"custom_data\", %{\"foo\": \"bar\"})\n  end\nend\n```\n\nThis can be added to the config with:\n```ex\nconfig :appsignal, custom_on_create_fun: &MyApp.Appsignal.custom_on_create_fun/1\n```","ref":"Appsignal.Tracer.html#custom_on_create_fun/1"},{"type":"function","title":"Appsignal.Tracer.delete/1","doc":"Removes the process' spans from the registry.","ref":"Appsignal.Tracer.html#delete/1"},{"type":"function","title":"Appsignal.Tracer.ignore/0","doc":"Ignores the current process.","ref":"Appsignal.Tracer.html#ignore/0"},{"type":"function","title":"Appsignal.Tracer.ignore/1","doc":"Ignores the given process.","ref":"Appsignal.Tracer.html#ignore/1"},{"type":"function","title":"Appsignal.Tracer.lookup/1","doc":"Finds the span in the registry table.","ref":"Appsignal.Tracer.html#lookup/1"},{"type":"function","title":"Appsignal.Tracer.root_span/0","doc":"Returns the root span in the current process.","ref":"Appsignal.Tracer.html#root_span/0"},{"type":"function","title":"Appsignal.Tracer.root_span/1","doc":"Returns the root span in the passed pid's process.","ref":"Appsignal.Tracer.html#root_span/1"},{"type":"type","title":"Appsignal.Tracer.option/0","doc":"","ref":"Appsignal.Tracer.html#t:option/0"},{"type":"type","title":"Appsignal.Tracer.options/0","doc":"","ref":"Appsignal.Tracer.html#t:options/0"},{"type":"module","title":"Appsignal.Transaction","doc":"","ref":"Appsignal.Transaction.html"},{"type":"function","title":"Appsignal.Transaction.complete/1","doc":"","ref":"Appsignal.Transaction.html#complete/1"},{"type":"function","title":"Appsignal.Transaction.finish/1","doc":"","ref":"Appsignal.Transaction.html#finish/1"},{"type":"function","title":"Appsignal.Transaction.generate_id/0","doc":"","ref":"Appsignal.Transaction.html#generate_id/0"},{"type":"function","title":"Appsignal.Transaction.set_action/1","doc":"","ref":"Appsignal.Transaction.html#set_action/1"},{"type":"function","title":"Appsignal.Transaction.set_error/3","doc":"","ref":"Appsignal.Transaction.html#set_error/3"},{"type":"function","title":"Appsignal.Transaction.set_error/4","doc":"","ref":"Appsignal.Transaction.html#set_error/4"},{"type":"function","title":"Appsignal.Transaction.set_sample_data/2","doc":"","ref":"Appsignal.Transaction.html#set_sample_data/2"},{"type":"module","title":"Appsignal.TransactionRegistry","doc":"","ref":"Appsignal.TransactionRegistry.html"},{"type":"function","title":"Appsignal.TransactionRegistry.lookup/1","doc":"","ref":"Appsignal.TransactionRegistry.html#lookup/1"},{"type":"function","title":"Appsignal.TransactionRegistry.register/1","doc":"","ref":"Appsignal.TransactionRegistry.html#register/1"},{"type":"module","title":"Appsignal.Utils.ArgumentCleaner","doc":"","ref":"Appsignal.Utils.ArgumentCleaner.html"},{"type":"function","title":"Appsignal.Utils.ArgumentCleaner.clean/1","doc":"","ref":"Appsignal.Utils.ArgumentCleaner.html#clean/1"},{"type":"function","title":"Appsignal.Utils.ArgumentCleaner.clean/2","doc":"","ref":"Appsignal.Utils.ArgumentCleaner.html#clean/2"},{"type":"function","title":"Appsignal.Utils.ArgumentCleaner.clean_literal/1","doc":"","ref":"Appsignal.Utils.ArgumentCleaner.html#clean_literal/1"},{"type":"module","title":"Appsignal.Utils.Literal","doc":"","ref":"Appsignal.Utils.Literal.html"},{"type":"task","title":"mix appsignal.demo","doc":"","ref":"Mix.Tasks.Appsignal.Demo.html"},{"type":"function","title":"Mix.Tasks.Appsignal.Demo.run/1","doc":"","ref":"Mix.Tasks.Appsignal.Demo.html#run/1"},{"type":"task","title":"mix appsignal.diagnose","doc":"","ref":"Mix.Tasks.Appsignal.Diagnose.html"},{"type":"function","title":"Mix.Tasks.Appsignal.Diagnose.run/1","doc":"","ref":"Mix.Tasks.Appsignal.Diagnose.html#run/1"},{"type":"function","title":"Mix.Tasks.Appsignal.Diagnose.send_report_to_appsignal/2","doc":"","ref":"Mix.Tasks.Appsignal.Diagnose.html#send_report_to_appsignal/2"},{"type":"task","title":"mix appsignal.install","doc":"","ref":"Mix.Tasks.Appsignal.Install.html"},{"type":"function","title":"Mix.Tasks.Appsignal.Install.run/1","doc":"","ref":"Mix.Tasks.Appsignal.Install.html#run/1"},{"type":"extras","title":"AppSignal for Elixir","doc":"# AppSignal for Elixir\n\n[![Build Status](https://travis-ci.org/appsignal/appsignal-elixir.png?branch=main)](https://travis-ci.org/appsignal/appsignal-elixir)\n[![Hex pm](http://img.shields.io/hexpm/v/appsignal.svg?style=flat)](https://hex.pm/packages/appsignal)\n\nAppSignal for Elixir monitors errors, performance and servers for Elixir\napplications.\n\n- [AppSignal.com website](https://www.appsignal.com/elixir)\n- [AppSignal for Elixir documentation](https://docs.appsignal.com/elixir/)\n- [Package documentation](https://hexdocs.pm/appsignal/)\n- [Support][contact]","ref":"readme.html"},{"type":"extras","title":"Installation - AppSignal for Elixir","doc":"Please follow the [installation\nguide](https://docs.appsignal.com/elixir/installation.html) on how to install\nand use this library.\n\nThen, add custom instrumentation or use one of the framework integrations to\nautomatically gain performance insights and error notifications. Currently,\nAppSignal has framework integrations for\n[Plug](https://github.com/appsignal/appsignal-elixir-plug) and\n[Phoenix](https://github.com/appsignal/appsignal-elixir-phoenix) and\napplications.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AppSignal for Elixir","doc":"AppSignal will automatically monitor requests, report any exceptions that are\nthrown and any performance issues that might have occurred.\n\nYou can also add extra information to requests by adding custom\ninstrumentation. Read more in our [instrumentation\nguide](https://docs.appsignal.com/elixir/instrumentation/).","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - AppSignal for Elixir","doc":"A complete list of all configurable options for AppSignal for Elixir is\navailable in [our\ndocumentation](https://docs.appsignal.com/elixir/configuration/).","ref":"readme.html#configuration"},{"type":"extras","title":"Development - AppSignal for Elixir","doc":"","ref":"readme.html#development"},{"type":"extras","title":"Setup - AppSignal for Elixir","doc":"Before you can start developing on the AppSignal for Elixir project make sure\nyou have [Elixir installed](http://elixir-lang.org/install.html).\n\nThis repository is managed by [mono](https://github.com/appsignal/mono/).\nInstall mono on your local machine by [following the mono installation\nsteps](https://github.com/appsignal/mono/#installation).\n\nThen make sure you have all the project's dependencies installed by running the\nfollowing command:\n\n    $ mono bootstrap","ref":"readme.html#setup"},{"type":"extras","title":"Testing - AppSignal for Elixir","doc":"Testing is done with ExUnit and can be run with the `mix test` command. You can\nalso supply a path to a specific file path you want to test and even a specific\nline on which the test you want to run is defined.\n\n    $ mono test\n    # The original command can still be used\n    $ mix test\n    $ mix test test/appsignal/some_test.ex:123\n\nThis project has several different test suites defined with different mix\nenvironments. You can run them by specifying the specific type of test suite in\nthe `MIX_ENV` environment variable.\n\n    # Default\n    $ MIX_ENV=test mix test\n\n    # Run the test suite with the NIF inoperational. This will generate errors\n    # because the NIF is not active, but should run without failures.\n    $ MIX_ENV=test_no_nif mix test","ref":"readme.html#testing"},{"type":"extras","title":"Benchmarking - AppSignal for Elixir","doc":"This package uses benchee to benchmark code. To run the benchmarker:\n\n    $ MIX_ENV=bench mix run bench/ .exs","ref":"readme.html#benchmarking"},{"type":"extras","title":"AddressSanitizer - AppSignal for Elixir","doc":"A memory testing setup is included to detect memory errors in the NIF.\nIt's set up in a Docker container to ensure reproducability.\n\nTo run the tests, build the container, which will build a version of the NIF with AddressSanitizer enabled.\nThen, run it with an `APPSIGNAL_PUSH_API_KEY` and `APPSIGNAL_APP_NAME` set to ensure AppSignal is enabled, and to be able to verify that data appears in AppSignal after running the test:\n\n    docker build --platform linux/amd64 -t appsignal-elixir-asan .\n    docker run \\\n      --env APPSIGNAL_PUSH_API_KEY=00000000-0000-0000-0000-000000000000 \\\n      --env APPSIGNAL_APP_NAME=\"appsignal-elixir\" \\\n      --rm \\\n      -- \\\n      appsignal-elixir-asan\n\nThis test runs `spans.exs`, which is a script that calls most functions in the NIF.","ref":"readme.html#addresssanitizer"},{"type":"extras","title":"Branches and versions - AppSignal for Elixir","doc":"The `main` branch corresponds to the current release of the\nlibrary. The `develop` branch is used for development of features that\nwill end up in the next minor release. If you fix a bug open a pull\nrequest on `main`, if it's a new feature on `develop`.","ref":"readme.html#branches-and-versions"},{"type":"extras","title":"Making changes - AppSignal for Elixir","doc":"When making changes to the project that require a release, [add a\nchangeset](https://github.com/appsignal/mono/#changeset-add) that will be used\nto update the generated `CHANGELOG.md` file upon\n[release](#publishing-new-version).\n\n    $ mono changeset add","ref":"readme.html#making-changes"},{"type":"extras","title":"Publishing new versions - AppSignal for Elixir","doc":"1. Merge the `develop` branch to `main` if necessary.\n-  Run [`mono publish`](https://github.com/appsignal/mono/#publish) and follow\n   the instructions.","ref":"readme.html#publishing-new-versions"},{"type":"extras","title":"Updating the CI build matrix - AppSignal for Elixir","doc":"1. Update `.semaphore/versions.rb` to add or remove Elixir/OTP versions, or `.semaphore/semaphore.yml.erb`.\n2. Run `script/generate_ci_matrix`.","ref":"readme.html#updating-the-ci-build-matrix"},{"type":"extras","title":"Contributing - AppSignal for Elixir","doc":"Thinking of contributing to our Elixir package? Awesome! 🚀\n\nPlease follow our [Contributing guide][contributing-guide] in our\ndocumentation and follow our [Code of Conduct][coc].\n\nAlso, we would be very happy to send you Stroopwafles. Have look at everyone\nwe send a package to so far on our [Stroopwafles page][waffles-page].","ref":"readme.html#contributing"},{"type":"extras","title":"Support - AppSignal for Elixir","doc":"[Contact us][contact] and speak directly with the engineers working on\nAppSignal. They will help you get set up, tweak your code and make sure you get\nthe most out of using AppSignal.\n\nAlso see our [SUPPORT.md file](SUPPORT.md).","ref":"readme.html#support"},{"type":"extras","title":"License - AppSignal for Elixir","doc":"The AppSignal for Elixir package source code is released under the MIT License.\nCheck the [LICENSE](LICENSE) file for more information.\n\n[contact]: mailto:support@appsignal.com\n[contributing-guide]: https://docs.appsignal.com/appsignal/contributing.html\n[coc]: https://docs.appsignal.com/appsignal/code-of-conduct.html\n[waffles-page]: https://appsignal.com/waffles","ref":"readme.html#license"},{"type":"extras","title":"AppSignal for Elixir changelog","doc":"# AppSignal for Elixir changelog","ref":"changelog.html"},{"type":"extras","title":"2.10.2 - AppSignal for Elixir changelog","doc":"_Published on 2024-05-14._","ref":"changelog.html#2-10-2"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [1a87c94a](https://github.com/appsignal/appsignal-elixir/commit/1a87c94a6f6c1b972aa68507e4a9f1243b9dd570) patch - Support Kamal-based deployments. Read the `KAMAL_VERSION` environment variable, which Kamal exposes within the deployed container, if present, and use it as the application revision if it is not set. This will automatically report deploy markers for applications using Kamal.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [a19671f6](https://github.com/appsignal/appsignal-elixir/commit/a19671f6f165a7957c39516f76a69f08e9e22ab5) patch - Log debug messages when metrics are received for easier debugging.","ref":"changelog.html#changed"},{"type":"extras","title":"2.10.1 - AppSignal for Elixir changelog","doc":"_Published on 2024-04-25._","ref":"changelog.html#2-10-1"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [5a7810c8](https://github.com/appsignal/appsignal-elixir/commit/5a7810c81a20961418285b6af8da47694c4b5b16) patch - Fix the Phoenix `filter_parameters` config option support for partial key matches. When configuring `config :phoenix, filter_parameters` with `[\"key\"]` or `{:discard, [\"key\"]}`, it now also matches partial keys like `\"my_key\"`, just like Phoenix's logger does.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.10.0 - AppSignal for Elixir changelog","doc":"_Published on 2024-04-22._","ref":"changelog.html#2-10-0"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [840e6c0b](https://github.com/appsignal/appsignal-elixir/commit/840e6c0bd9934dba1614f7aae3d60350975f3be3) minor - _Heartbeats are currently only available to beta testers. If you are interested in trying it out, [send an email to support@appsignal.com](mailto:support@appsignal.com?subject=Heartbeat%20beta)!_\n  \n  ---\n  \n  Add heartbeats support. You can send heartbeats directly from your code, to track the execution of certain processes:\n  \n  ```elixir\n  def send_invoices do\n    # ... your code here ...\n    Appsignal.heartbeat(\"send_invoices\")\n  end\n  ```\n  \n  You can pass a function to `Appsignal.heartbeat`, to report to AppSignal both when the process starts, and when it finishes, allowing you to see the duration of the process:\n  \n  ```elixir\n  def send_invoices do\n    Appsignal.heartbeat(\"send_invoices\", fn ->\n      # ... your code here ...\n    end)\n  end\n  ```\n  \n  If an exception is thrown within the function, the finish event will not be reported to AppSignal, triggering a notification about the missing heartbeat. The exception will bubble outside of the heartbeat function.\n- [d56d3ebd](https://github.com/appsignal/appsignal-elixir/commit/d56d3ebd2286ee4e4aa75553aeaf49ec1c312bbe) patch - Implement the `ignore_logs` configuration option, which can also be configured as the `APPSIGNAL_IGNORE_LOGS` environment variable.\n  \n  The value of `ignore_logs` is a list (comma-separated, when using the environment variable) of log line messages that should be ignored. For example, the value `\"start\"` will cause any message containing the word \"start\" to be ignored. Any log line message containing a value in `ignore_logs` will not be reported to AppSignal.\n  \n  The values can use a small subset of regular expression syntax (specifically, `^`, `$` and `.*`) to narrow or expand the scope of lines that should be matched.\n  \n  For example, the value `\"^start$\"` can be used to ignore any message that is _exactly_ the word \"start\", but not messages that merely contain it, like \"Process failed to start\". The value `\"Task .* succeeded\"` can be used to ignore messages about task success regardless of the specific task name.","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [38511da4](https://github.com/appsignal/appsignal-elixir/commit/38511da476be461bbe2d4f97cf58e5d5ba5e828a) patch - Remove broken link about 1.x upgrade","ref":"changelog.html#fixed"},{"type":"extras","title":"2.9.2 - AppSignal for Elixir changelog","doc":"_Published on 2024-03-22._","ref":"changelog.html#2-9-2"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [4567ce04](https://github.com/appsignal/appsignal-elixir/commit/4567ce04279ebd53570c84870a81bf7168a91091) patch - Drop non-500 Plug errors in add_error/3","ref":"changelog.html#fixed"},{"type":"extras","title":"2.9.1 - AppSignal for Elixir changelog","doc":"_Published on 2024-03-20._","ref":"changelog.html#2-9-1"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [c833c8a4](https://github.com/appsignal/appsignal-elixir/commit/c833c8a4bb82febb0a45b1fb8a5fdeff238444be) patch - Implement CPU count configuration option. Use it to override the auto-detected, cgroups-provided number of CPUs that is used to calculate CPU usage percentages.\n  \n  To set it, use the `cpu_count` configuration option, or the `APPSIGNAL_CPU_COUNT` environment variable.","ref":"changelog.html#added"},{"type":"extras","title":"2.9.0 - AppSignal for Elixir changelog","doc":"_Published on 2024-03-06._","ref":"changelog.html#2-9-0"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [be785ea9](https://github.com/appsignal/appsignal-elixir/commit/be785ea99d55d04f42639ed7a93b8c5b458240dc) patch - Add histogram support to the OpenTelemetry HTTP server. This allows OpenTelemetry-based instrumentations to report histogram data to AppSignal as distribution metrics.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [2d3130fd](https://github.com/appsignal/appsignal-elixir/commit/2d3130fd5d6bbdcdb91e35f581857e05c8ec292a) minor - **Breaking change**: Normalize CPU metrics for cgroups v1 systems. When we can detect how many CPUs are configured in the container's limits, we will normalize the CPU percentages to a maximum of 100%. This is a breaking change. Triggers for CPU percentages that are configured for a CPU percentage higher than 100% will no longer trigger after this update. Please configure triggers to a percentage with a maximum of 100% CPU percentage.\n- [1566a4a8](https://github.com/appsignal/appsignal-elixir/commit/1566a4a8cf0536203027438b01cf1054c4afbf01) patch - Update the Mix config import in the `config/appsignal.exs` file to use `import Config`, rather than the deprecated `use Mix.Config`.\n- [2d3130fd](https://github.com/appsignal/appsignal-elixir/commit/2d3130fd5d6bbdcdb91e35f581857e05c8ec292a) patch - Support fractional CPUs for cgroups v2 metrics. Previously a CPU count of 0.5 would be interpreted as 1 CPU. Now it will be correctly seen as half a CPU and calculate CPU percentages accordingly.\n- [fb7568ac](https://github.com/appsignal/appsignal-elixir/commit/fb7568aced9ddcf1eb055c590ff1554d603c81a7) patch - Update bundled trusted root certificates.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [ad0fdb0c](https://github.com/appsignal/appsignal-elixir/commit/ad0fdb0c2142eaf53f0129568164ce4c96dd1337) patch - Fix (sub)traces not being reported in their entirety when the OpenTelemetry exporter sends one trace in multiple export requests. This would be an issue for long running traces, that are exported in several requests.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.8.3 - AppSignal for Elixir changelog","doc":"_Published on 2024-02-01._","ref":"changelog.html#2-8-3"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [e685b22f](https://github.com/appsignal/appsignal-elixir/commit/e685b22f1d56beeedd66587002b4e839896ce1c9) patch - Set data on spans with the `custom_on_create_fun` hook. This hook is called upon the creation of every span. This can be useful to add tags to internal traces and otherwise difficult to access traces.\n  \n  This won't be necessary for most scenarios. We recommend following [our tagging guide](https://docs.appsignal.com/guides/custom-data/tagging-request.html#elixir) instead.\n  \n  ```elixir\n  defmodule MyApp.Appsignal do\n    def custom_on_create_fun(_span) do\n      Appsignal.Span.set_sample_data(Appsignal.Tracer.root_span, \"tags\", %{\"locale\": \"en\"})\n    end\n  end\n  ```\n  \n  ```elixir\n  # config/config.exs\n  config :appsignal, custom_on_create_fun: &MyApp.Appsignal.custom_on_create_fun/1\n  ```","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [924a3ffa](https://github.com/appsignal/appsignal-elixir/commit/924a3ffa3e0e456234df3c8a56c4a7cea875c214) patch - Make the debug log message for OpenTelemetry spans from libraries we don't automatically recognize more clear. Mention the span id and the instrumentation library.\n- [924a3ffa](https://github.com/appsignal/appsignal-elixir/commit/924a3ffa3e0e456234df3c8a56c4a7cea875c214) patch - Fix an issue where queries containing a MySQL leading type indicator would only be partially sanitised.","ref":"changelog.html#changed"},{"type":"extras","title":"2.8.2 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-8-2"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [47f4a8df](https://github.com/appsignal/appsignal-elixir/commit/47f4a8df24250b7985178372e59408b3feae0af8) patch - Add `Appsignal.Ecto.Repo` to support parallel preloads.\n  \n  For AppSignal to be able to instrument parallel preloads, the current instrumentation context needs to be passed from the Elixir process that spawns the preload to the short-lived processes that run each of the parallel queries.\n  \n  By replacing `use Ecto.Repo` with `use Appsignal.Ecto.Repo`, the appropriate telemetry context will be passed so that AppSignal can correctly instrument these queries:\n  \n  ```elixir\n  defmodule MyApp.Repo do\n    # replace `use Ecto.Repo` with `use Appsignal.Ecto.Repo`\n    use Appsignal.Ecto.Repo,\n      otp_app: :my_app,\n      adapter: Ecto.Adapters.Postgres\n  end\n  ```","ref":"changelog.html#added"},{"type":"extras","title":"2.8.1 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-8-1"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [40dc85ef](https://github.com/appsignal/appsignal-elixir/commit/40dc85efb1a9ecb5803dc82c88cb37c1c8ccc72d) patch - Fix disk usage returning a Vec with no entries on Alpine Linux when the `df --local` command fails.\n- [92d948fa](https://github.com/appsignal/appsignal-elixir/commit/92d948fa1f8db9546a9074789d7e1ff7264aa720) patch - Add support for lists in the sample data as root values on spans, as shown below. Previously we only supported lists as nested objects in maps.\n  \n  ```elixir\n  Appsignal.Span.set_sample_data(\n    Appsignal.Tracer.root_span,\n    \"custom_data\",\n    [\n      \"value 1\",\n      \"value 2\"\n    ]\n  )\n  ```","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - AppSignal for Elixir changelog","doc":"- [40dc85ef](https://github.com/appsignal/appsignal-elixir/commit/40dc85efb1a9ecb5803dc82c88cb37c1c8ccc72d) patch - Remove the `appsignal_set_host_gauge` and `appsignal_set_process_gauge` extension functions. These functions were already deprecated and did not report any metrics.","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [9ec351a7](https://github.com/appsignal/appsignal-elixir/commit/9ec351a7e4fc77ac2ca1976191235793f625888d) patch - Fix missing error metrics for the error rate and error count graphs in some scenarios, like with Node.js Koa apps.\n- [a339fc1d](https://github.com/appsignal/appsignal-elixir/commit/a339fc1d9ef8f8c34c32c5415bd32dbd0cb6b754) patch - Add support for keywords lists in sample data on spans. These would previously be shown an empty list.\n  \n  ```elixir\n  Appsignal.Span.set_sample_data(\n    Appsignal.Tracer.root_span,\n    \"custom_data\",\n    %{\"keyword_list\": [foo: \"some value\", \"bar\": \"other value\"]}\n  )\n  ```","ref":"changelog.html#fixed"},{"type":"extras","title":"2.8.0 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-8-0"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [8e8911f0](https://github.com/appsignal/appsignal-elixir/commit/8e8911f0091d5a74633235a5e4371fe0369e405f) minor - Always use Jason to encode JSON. This removes the need to install either Jason or Poison alongside AppSignal, simplifying our installation instructions.\n- [9dbf8d82](https://github.com/appsignal/appsignal-elixir/commit/9dbf8d829e5aa4cbb1c73a8c5594cb0b9ab9d31a) patch - Filter more disk mountpoints for disk usage and disk IO stats. This helps reduce noise in the host metrics by focussing on more important mountpoints.\n  \n  The following mountpoint are ignored. Any mountpoint containing:\n  \n  - `/etc/hostname`\n  - `/etc/hosts`\n  - `/etc/resolv.conf`\n  - `/snap/`\n  - `/proc/`","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [9dbf8d82](https://github.com/appsignal/appsignal-elixir/commit/9dbf8d829e5aa4cbb1c73a8c5594cb0b9ab9d31a) patch - - Support disk usage reporting (using `df`) on Alpine Linux. This host metric would report an error on Alpine Linux.\n  - When a disk mountpoint has no inodes usage percentage, skip the mountpoint, and report the inodes information successfully for the inodes that do have an inodes usage percentage.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.13 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-13"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [c883847a](https://github.com/appsignal/appsignal-elixir/commit/c883847aff145d35a4d925e54532648c3616da23) patch - Bump agent to eec7f7b\n  \n  Updated the probes dependency to 0.5.2. CPU usage is now normalized to the number of CPUs available to the container. This means that a container with 2 CPUs will have its CPU usage reported as 50% when using 1 CPU instead of 100%. This is a breaking change for anyone using the cpu probe.\n  \n  If you have CPU triggers set up based on the old behaviour, you might need to update those to these new normalized values to get the same behaviour. Note that this is needed only if the AppSignal integration package you're using includes this change.","ref":"changelog.html#changed"},{"type":"extras","title":"2.7.12 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-12"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [33f08759](https://github.com/appsignal/appsignal-elixir/commit/33f08759b1e4f00fb929d6c5a7d6bd86516048d3) patch - Improve Ecto transaction instrumentation. Queries performed as part of an\n  `Ecto.Multi` or an `Ecto.Repo.transaction` were already individually\n  instrumented, but now they are displayed in the event timeline as child events\n  of a broader transaction event. An additional event is added at the end of the\n  transaction, to denote whether the transaction was committed or rolled back.","ref":"changelog.html#changed"},{"type":"extras","title":"2.7.11 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-11"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [dae88280](https://github.com/appsignal/appsignal-elixir/commit/dae8828059cf6fe18a3ff042c23988af56e86006) patch - Bump agent to b604345.\n  \n  - Add an exponential backoff to the retry sleep time to bind to the StatsD, NGINX and OpenTelemetry exporter ports. This gives the agent a longer time to connect to the ports if they become available within a 4 minute window.\n  - Changes to the agent logger:\n    - Logs from the agent and extension now use a more consistent format in logs for spans and transactions.\n    - Logs that are for more internal use are moved to the trace log level and logs that are useful for debugging most support issues are moved to the debug log level. It should not be necessary to use log level 'trace' as often anymore. The 'debug' log level should be enough.\n  - Add `running_in_container` to agent diagnose report, to be used primarily by the Python package as a way to detect if an app's host is a container or not.\n- [e6c4c79f](https://github.com/appsignal/appsignal-elixir/commit/e6c4c79f8096fe88c5d7cc3983e91096e3aa946f) patch - Bump agent to 1dd2a18.\n  \n  - When adding an SQL body attribute via the extension, instead of truncating the body first and sanitising it later, sanitise it first and truncate it later. This prevents an issue where queries containing very big values result in truncated sanitisations.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [197e3610](https://github.com/appsignal/appsignal-elixir/commit/197e3610d0c4edfaaa61e3715d46b073f56e115e) patch - Avoid reporting an Oban insert job event as a new incident. This should fix an issue where \"insert job\" events with little information show up in AppSignal as their own incidents when Oban jobs are inserted from an uninstrumented context that has no parent spans.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.10 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-10"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [68ec699e](https://github.com/appsignal/appsignal-elixir/commit/68ec699ead0c82dff11c73dc2ec1cf1cd928d4d0) patch - Implement an Erlang :logger handler for sending logs from AppSignal, in\n  preparation for the eventual deprecation of Elixir logger backends.\n  \n  Add a convenience method to configure this logger handler automatically,\n  with the right settings for AppSignal:\n  \n  ```elixir\n  Appsignal.Logger.Handler.add(\"my_app\", :plaintext)\n  ```\n  \n  To remove the logging handler, call the `.remove` method:\n  \n  ```elixir\n  Appsignal.Logger.Handler.remove()\n  ```","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [cc526cb6](https://github.com/appsignal/appsignal-elixir/commit/cc526cb63bb4894cd1e6c2e67f9b0f0fee2b5271) patch - Bump agent to e8207c1.\n  \n  - Add `memory_in_percentages` and `swap_in_percentages` host metrics that represents metrics in percentages.\n  - Ignore `/snap/` disk mountpoints.\n  - Fix issue with the open span count in logs being logged as a negative number.\n  - Fix agent's TCP server getting stuck when two requests are made within the same fraction of a second.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [bcbc1c6a](https://github.com/appsignal/appsignal-elixir/commit/bcbc1c6aa3f28c1bcba95866182964da9f10cc4b) patch - Fix configuration options set with atoms. The options `log` and `log_level` can now be set as an Atom, and we'll cast them to a string internally to avoid any `ArgumentError` from the Nif.\n- [92a7e886](https://github.com/appsignal/appsignal-elixir/commit/92a7e886449b6bdaa8e553585b1084e6d6b314d5) patch - Fix support for `warning` `log_level`. Only `warn` would work, now `warning` also works as documented.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.9 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-9"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [ebd39c39](https://github.com/appsignal/appsignal-elixir/commit/ebd39c39553f55249cbb88e21e67c9c3a01fec85) patch - Bump agent to 6133900.\n  \n  - Fix `disk_inode_usage` metric name format to not be interpreted as a JSON object.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.8 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-8"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [489615ae](https://github.com/appsignal/appsignal-elixir/commit/489615aee6f66da503ab57d0a5a6312111532602) patch - Add the `host_role` config option. This config option can be set per host to generate some metrics automatically per host and possibly do things like grouping in the future.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [7b3875b2](https://github.com/appsignal/appsignal-elixir/commit/7b3875b2c223114dd98dd9fbf55eb1e762d8984b) patch - Bump agent to 6bec691.\n  \n  - Upgrade `sql_lexer` to v0.9.5. It adds sanitization support for the `THEN` and `ELSE` logical operators.\n- [7781f405](https://github.com/appsignal/appsignal-elixir/commit/7781f40579750386525b301ae7c1a3c475ca8b54) patch - Bump agent to version d789895.\n  \n  - Increase short data truncation from 2000 to 10000 characters.","ref":"changelog.html#changed"},{"type":"extras","title":"2.7.7 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-7"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [75e70db2](https://github.com/appsignal/appsignal-elixir/commit/75e70db27ec8f84faaf647522fb3027cc41b2f9c) patch - Use `RENDER_GIT_COMMIT` environment variable as revision if no revision is specified.\n- [7c3103ae](https://github.com/appsignal/appsignal-elixir/commit/7c3103aef9b3621f562ee7bccaf1f591ba5cb91c) patch - Allow JSON and Logfmt log messages\n- [2b3eab1d](https://github.com/appsignal/appsignal-elixir/commit/2b3eab1dd06bf212547f18f9732b7d091f2cd76a) patch - Allow configuration of the agent's TCP and UDP servers using the `bind_address` config option. This is by default set to `127.0.0.1`, which only makes it accessible from the same host. If you want it to be accessible from other machines, use `0.0.0.0` or a specific IP address.\n- [08aedeef](https://github.com/appsignal/appsignal-elixir/commit/08aedeefe8715b963587798bbacc4ab1d1f043dd) patch - Report total CPU usage host metric for VMs. This change adds another `state` tag value on the `cpu` metric called `total_usage`, which reports the VM's total CPU usage in percentages.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [ece48144](https://github.com/appsignal/appsignal-elixir/commit/ece481440c571ce792ee4bab86a297ce7eb3a1bf) patch - Bump agent to 32590eb.\n  \n  - Only ignore disk metrics that start with \"loop\", not all mounted disks that end with a number to report metrics for more disks.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [b7089a8e](https://github.com/appsignal/appsignal-elixir/commit/b7089a8e1ea9340ed28692e75d7976e653edf891) patch - Handle atoms for categories in transaction_event decorator","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.6 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-6"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [be411435](https://github.com/appsignal/appsignal-elixir/commit/be41143553a8d6a37e2af12e688f5625cb1d3de8) patch - Add `set_sample_data_if_nil` function to `Appsignal.Span`, allowing for parameters to be set only if they would not override other parameters.\n- [be411435](https://github.com/appsignal/appsignal-elixir/commit/be41143553a8d6a37e2af12e688f5625cb1d3de8) patch - Use `RENDER_GIT_COMMIT` environment variable as revision if no revision is specified.","ref":"changelog.html#added"},{"type":"extras","title":"2.7.5 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-5"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [5e5918f5](https://github.com/appsignal/appsignal-elixir/commit/5e5918f5938ce1a673659c26663f74becdb0425e) patch - Improve argument cleaning.\n  \n  The output should appear in a more familiar format for Elixir developers. Potentially personally identifiable data is removed and the output is truncated to make it easier to understand, while attempting to provide enough information to differentiate between different function clauses.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [af402113](https://github.com/appsignal/appsignal-elixir/commit/af4021135602263d7285050a1f298c8a145b7401) patch - Improve Tracer performance by removing duplicate runtime configuration and storage checks","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.4 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-4"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [dcdac33e](https://github.com/appsignal/appsignal-elixir/commit/dcdac33e3ab25bf9e003507579201e3e34174dc4) patch - Add handling for cowboy error edge cases to prevent error backend crashes","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.3 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-3"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [37810e11](https://github.com/appsignal/appsignal-elixir/commit/37810e1179cf05b295dbba4c01aac3a0cb9ba80c) patch - Allow configuration of the agent's StatsD server port through the `statsd_port` option.\n- [0caf8330](https://github.com/appsignal/appsignal-elixir/commit/0caf833097f7d44a310d314083050634938ab583) patch - Add automatic instrumentation for Tesla.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [7e7c097d](https://github.com/appsignal/appsignal-elixir/commit/7e7c097d70b2c41466f64c1f531451a60652b087) patch - Bump agent to fd8ee9e.\n  \n  - Rely on APPSIGNAL_RUNNING_IN_CONTAINER config option value before other environment factors to determine if the app is running in a container.\n  - Fix container detection for hosts running Docker itself.\n  - Add APPSIGNAL_STATSD_PORT config option.","ref":"changelog.html#changed"},{"type":"extras","title":"2.7.2 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-2"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [49467767](https://github.com/appsignal/appsignal-elixir/commit/4946776794013bd8dc381e5dce2b665157fbb3cf) patch - Update agent to v-f9b0c15\n  \n  - Add more span API logging.","ref":"changelog.html#changed"},{"type":"extras","title":"2.7.1 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-1"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [8b8d06fa](https://github.com/appsignal/appsignal-elixir/commit/8b8d06fad959f9cc313844455434e0e8f483e77f) patch - Trim SQL attributes in spans. This fixes an issue where very big payloads are sent from the Elixir integration.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.7.0 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-0"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [885c3618](https://github.com/appsignal/appsignal-elixir/commit/885c36183c76f39811b20fa14460c197d601848f) patch - Update agent to version 6f29190.\n  \n  - Log revision config in boot debug log.\n  - Update internal agent CLI start command.\n  - Rename internal `_APPSIGNAL_ENVIRONMENT` variable to `_APPSIGNAL_APP_ENV` to be consistent with the public version.\n- [87946896](https://github.com/appsignal/appsignal-elixir/commit/87946896499f19702136129fc1502332648fa3a9) patch - Update bundled trusted root certificates.\n- [704da7a9](https://github.com/appsignal/appsignal-elixir/commit/704da7a95ad98b2f3cce1f32eddb1cbf5ed0702f) patch - Bump agent to 4a0a036. Fix a transmission requeueing problem with queued payloads.","ref":"changelog.html#changed"},{"type":"extras","title":"2.7.0-beta.1 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-7-0-beta-1"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [45deeedd](https://github.com/appsignal/appsignal-elixir/commit/45deeedd82273df88812fd96e25260dab9f71a00) minor - Add Absinthe instrumentation","ref":"changelog.html#added"},{"type":"extras","title":"2.6.1 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-6-1"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [2bc1346f](https://github.com/appsignal/appsignal-elixir/commit/2bc1346f2cf6657e60df5e173c02cdd979c51217) patch - Handle unexpected events in Logger backend","ref":"changelog.html#fixed"},{"type":"extras","title":"2.6.0 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-6-0"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [6462f802](https://github.com/appsignal/appsignal-elixir/commit/6462f802ae1724e075b404e476272a11e0cbc0f3) minor - Add Logger backend to redirect Elixir logs to AppSignal.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [2d424448](https://github.com/appsignal/appsignal-elixir/commit/2d42444884f74b459a97a97d268cdc576c152705) patch - Bump agent to 8d042e2.\n  \n  - Support multiple log formats.\n- [a886a2b7](https://github.com/appsignal/appsignal-elixir/commit/a886a2b7788602cbe5b95d17a0259013e7e9630b) patch - Bump agent to dee4fcb.\n  \n  - Support cgroups v2. Used by newer Docker engines to report host metrics. Upgrade if you receive no host metrics for Docker containers.\n  - Remove trailing comments in SQL queries, ensuring queries are grouped consistently.","ref":"changelog.html#changed"},{"type":"extras","title":"2.5.3 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-5-3"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [a4a23ded](https://github.com/appsignal/appsignal-elixir/commit/a4a23dedc53f19262a83ced76c69bf8597fde7e3) patch - Bump agent to 0d593d5\n  \n  - Report shared memory metric state.","ref":"changelog.html#changed"},{"type":"extras","title":"2.5.2 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-5-2"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [63adf596](https://github.com/appsignal/appsignal-elixir/commit/63adf596bd56f2da8bd2e843086d283f5137c24e) patch - Add NGINX metrics support. See [our documentation](https://docs.appsignal.com/metrics/nginx.html) for details.","ref":"changelog.html#added"},{"type":"extras","title":"2.5.1 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-5-1"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [837e0285](https://github.com/appsignal/appsignal-elixir/commit/837e0285a336854646967567d939a0277473c1a4) patch - Add config options to disable automatic Ecto, Finch and Oban instrumentations.\n  Set `instrument_ecto`, `instrument_finch` or `instrument_oban` to `false` in\n  order to disable that instrumentation.\n- [b3a77a73](https://github.com/appsignal/appsignal-elixir/commit/b3a77a73c5f8a136d0333c1c64154b3350cec28f) patch - Add a `report_oban_errors` config option to decide when to report Oban errors. When set to `\"all\"`, all errors will be reported; when set to `\"none\"`, no errors will be reported. Set it to `\"discard\"` to only report errors when the job is discarded due to the error and won't be re-attempted.\n- [e52997c8](https://github.com/appsignal/appsignal-elixir/commit/e52997c8dfa081822da840dd84d28e9bf6148259) patch - Add metadata functions for Plug/Phoenix apps","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [837e0285](https://github.com/appsignal/appsignal-elixir/commit/837e0285a336854646967567d939a0277473c1a4) patch - Fix the default value of `enable_error_backend` so it defaults to `true` when\n  the config option is not set.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.5.0 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-5-0"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [bc14f302](https://github.com/appsignal/appsignal-elixir/commit/bc14f30275cbdedb773835cc908f1d4b0c3161fa) minor - Add Oban instrumentation. Jobs processed by your Oban workers will now be instrumented with AppSignal, and job insertions will appear as events in your performance samples' event timelines.\n- [65107c60](https://github.com/appsignal/appsignal-elixir/commit/65107c60f46db7fe004f031c0b737dd71628d3d6) patch - Track the Operating System release/distro in the diagnose report. This helps us with debugging what exact version of Linux an app is running on, for example.","ref":"changelog.html#added"},{"type":"extras","title":"2.4.3 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-4-3"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [1b69bf4e](https://github.com/appsignal/appsignal-elixir/commit/1b69bf4e784850b35125003c67f2aaaae4504e8d) patch - Fix an issue where user configuration enabling metrics for Hackney would cause the AppSignal Agent installation to fail.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.4.2 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-4-2"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [a5c810d4](https://github.com/appsignal/appsignal-elixir/commit/a5c810d44b0ec1273cf1b4c7d4081371d6d74826) patch - Fix an issue where reporting an exception for a function call whose arguments contain a map of PID would raise a second exception instead.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.4.1 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-4-1"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [4473ffee](https://github.com/appsignal/appsignal-elixir/commit/4473ffeecb424d589aad59e5ec988bb37968e816) patch - Add enable_error_backend configuration option","ref":"changelog.html#changed"},{"type":"extras","title":"2.4.0 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-4-0"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [beb0c43b](https://github.com/appsignal/appsignal-elixir/commit/beb0c43b16b5f1efb9ba43c0449b682efd302375) minor - Support log collection from Elixir apps using the new AppSignal Logging feature. Learn more about [AppSignal's Logging on our docs](https://docs.appsignal.com/logging/platforms/integrations/nodejs.html).","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [b2dddb11](https://github.com/appsignal/appsignal-elixir/commit/b2dddb111d80bfaa66eee5df35590432a6e50786) patch - Replace arguments in stack traces with sanitized versions instead of stripping them out completely","ref":"changelog.html#changed"},{"type":"extras","title":"2.3.1 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-3-1"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [5a9b4b6c](https://github.com/appsignal/appsignal-elixir/commit/5a9b4b6ced14470e0af7c5111923673798d624d8) patch - Fix FunctionClauseError for old Finch versions. This change explicitly ignores events from old Finch versions, meaning only Finch versions 0.12 and above will be instrumented, but using Finch versions 0.11 and below won't cause an event handler crash.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.3.0 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-3-0"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [2aaf55be](https://github.com/appsignal/appsignal-elixir/commit/2aaf55bea35b339276aa7d5c1933f20f861ecb95) minor - Add Finch integration. HTTP requests performed with Finch will show up as events in the sample view.","ref":"changelog.html#added"},{"type":"extras","title":"2.2.19 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-19"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [be7825e1](https://github.com/appsignal/appsignal-elixir/commit/be7825e13bdcdb4a8c1100dd39a4afa990ea04fa) patch - Fix extension linking on Alpine Linux ARM64 systems.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.18 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-18"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [05f59d31](https://github.com/appsignal/appsignal-elixir/commit/05f59d312b2c093296e2eba8182d81deff2ecdbf) patch - Fix compile-time error about symbol names starting with a comma. Updated the linking script to not include the comma.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.17 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-17"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [b600e85a](https://github.com/appsignal/appsignal-elixir/commit/b600e85a3940fce6df899e0e78f110d4ceb512cd) patch - Fix compile-time warning about an unused funtion in the extension. The `_set_span_attribute_sql_string` function wasn't hooked up, which didn't produce any issues since the SQL queries coming from Ecto don't need to be sanitized any further (sensitive data is already stripped out). This patch still runs them through AppSignal's SQL sanitizer to fix the warning and behave as promised, theoretically.\n- [910ad1dd](https://github.com/appsignal/appsignal-elixir/commit/910ad1dd956d8c9a2adf526cf21584d0c90a0d98) patch - Fix compile-time error that broke linking on macOS 12.6, more specifically the latest Xcode at this time (version 14.0 14A309).","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.16 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-16"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [03b8306a](https://github.com/appsignal/appsignal-elixir/commit/03b8306a1a78ce4c29b5b90cd19656e4cb0f0a6e) patch - Bump agent to 06391fb\n  \n  - Accept \"warning\" value for the `log_level` config option.\n  - Add aarch64 Linux musl build.\n  - Improve debug logging from the extension.\n  - Fix high CPU issue for appsignal-agent when nothing could be read from the socket.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [4d72d791](https://github.com/appsignal/appsignal-elixir/commit/4d72d791401a6b70432eecd5d85a7f6afeec322a) patch - Always return :ok from Appsignal.config_change/3\n- [914f013b](https://github.com/appsignal/appsignal-elixir/commit/914f013b3d6ff865a6067409518e67aafdaf1ae5) patch - Always return the Span from span setter functions, to allow for chaining setter calls with optional values","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.15 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-15"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [ab876253](https://github.com/appsignal/appsignal-elixir/commit/ab876253936838369654f11bbcd387a7c52c3994) patch - Bump agent to v-d573c9b\n  \n  - Clean up payload storage before sending. Should fix issues with locally queued payloads blocking data from being sent.\n  - Add OpenTelemetry support for the Span API. Not currently implemented in this package's extension.","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [d66ad2d8](https://github.com/appsignal/appsignal-elixir/commit/d66ad2d84192d4c6e5e20b489023f8c0264c7c56) patch - Always return the Span from Span.set_attribute/3, making it easier to chain this function call.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.14 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-14"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [ffb3ab29](https://github.com/appsignal/appsignal-elixir/commit/ffb3ab299e2b7a09ab19cdb6ba60ab0accfe4496) patch - Fix compile-time error with empty configurations\n- [c3599ae9](https://github.com/appsignal/appsignal-elixir/commit/c3599ae9e496f15ca17eb536019223ade3bb0a8f) patch - Improve the error message on extension load failure. The error message will now print more details about the installed and expected architecture when they mismatch. This is most common on apps mounted on a container after first being installed on the host with a different architecture than the container.\n- [4ac415f1](https://github.com/appsignal/appsignal-elixir/commit/4ac415f19b4cb1a8344e23c3de74effc86ef7eb0) patch - Don't crash at compile time when AppSignal is not configured","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.13 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-13"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [26be6e58](https://github.com/appsignal/appsignal-elixir/commit/26be6e58443fab533206f230743da65c66d3bc89) patch - Fix session data by reverting the sample data key change","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.12 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-12"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [65c5d716](https://github.com/appsignal/appsignal-elixir/commit/65c5d71648a6e25dc91e3e310483e6ce5079cd53) patch - Don't set session data when the send_session_data configuration is set to false","ref":"changelog.html#added"},{"type":"extras","title":"2.2.11 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-11"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [e287e58c](https://github.com/appsignal/appsignal-elixir/commit/e287e58cd8baf3234ee7a2c4e9ded33c6f0fd719) patch - Allow ignoring specific pids through Tracer.ignore/1\n- [c325114a](https://github.com/appsignal/appsignal-elixir/commit/c325114aa6278d8b4f4cf9587cb288345f5c492f) patch - Log messages are now sent through a centralised logger, defaulting to logging\n  to the `/tmp/appsignal.log` file.\n  To log to standard output instead, set the `log` config property to `\"stdout\"`.\n- [96c60363](https://github.com/appsignal/appsignal-elixir/commit/96c60363b06f64ed43b1f8a88484ecde45c1710a) patch - Don't set parameters when the send_params configuration is set to false","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [bb6c7a65](https://github.com/appsignal/appsignal-elixir/commit/bb6c7a6514261a21d4ce44b9556db4d7ea77f9fb) patch - Add the config \"override\" source to better communicate and help debug when certain config options are set. This is used by the diagnose report. The override source is used to set the new config option value when a config option has been renamed, like `send_session_data`.\n- [003a2edd](https://github.com/appsignal/appsignal-elixir/commit/003a2eddf5f4fe376caf75d044beddb5f70f5037) patch - The extension installation will no longer fail when the CA certificate file is not accessible.\n- [db97b2f6](https://github.com/appsignal/appsignal-elixir/commit/db97b2f6593696de577da7971198afb1c4e6b83a) patch - Bump agent to v-bbc830a\n  \n  - Support batched statsd messages\n  - Set start times for spans with traceparents\n  - Check duration in transactions for negative and too high values\n- [709224ad](https://github.com/appsignal/appsignal-elixir/commit/709224ad62326f7ede0b86497fe9df87c3713a6d) patch - Bump agent to v-f57e6cb\n  \n  - Enable process metrics on Heroku and Dokku","ref":"changelog.html#changed"},{"type":"extras","title":"2.2.10 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-10"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [0469f4b2](https://github.com/appsignal/appsignal-elixir/commit/0469f4b2bd80822debd7e5163db13f46ee13e051) patch - Add `send_session_data` option to configure if session data is automatically included in\n  spans. By default this is turned on. It can be disabled by configuring\n  `send_session_data` to `false`.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [ffe65216](https://github.com/appsignal/appsignal-elixir/commit/ffe652167bb3bfe69b031e2d932ef95ab730a389) patch - Remove Ruby exclusive headers from request_headers defaults.\n- [c0a98928](https://github.com/appsignal/appsignal-elixir/commit/c0a98928fb331436f01b7b41212decf7ab949ed1) patch - Bump AppSignal agent version to 15ee07b. Add internal tracking of transmission duration.\n- [8c14f827](https://github.com/appsignal/appsignal-elixir/commit/8c14f82737381798a3c230275c99c4333f635238) patch - The diagnose library report now reports the agent version from the committed agent file,\n  rather than the downloaded version, which is reported in the installation report.","ref":"changelog.html#changed"},{"type":"extras","title":"Deprecated - AppSignal for Elixir changelog","doc":"- [0469f4b2](https://github.com/appsignal/appsignal-elixir/commit/0469f4b2bd80822debd7e5163db13f46ee13e051) patch - Deprecate `skip_session_data` option in favor of the newly introduced `send_session_data` option.\n  If it is configured, it will print a warning on AppSignal load, but will also retain its\n  functionality until the config option is fully removed in the next major release.","ref":"changelog.html#deprecated"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [e4ec8e68](https://github.com/appsignal/appsignal-elixir/commit/e4ec8e68abb1d625a0a4a0241e52b167a98a9f3d) patch - Prefer the value of the `log_level` config option, instead of the deprecated `debug` config option, when deciding whether to log a debug message. If `log_level` does not have a value, or its value is invalid, the values of the deprecated `debug` and `transaction_debug_mode` config options are taken into account.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.9 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-9"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [2b78e1e2](https://github.com/appsignal/appsignal-elixir/commit/2b78e1e2dfed237bfed38705411d837f1211c4b4) patch - Fix debug and transaction_debug_mode log options. If set, previously the log_level would remain \"info\", since version 2.2.8.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.8 - AppSignal for Elixir changelog","doc":"","ref":"changelog.html#2-2-8"},{"type":"extras","title":"Added - AppSignal for Elixir changelog","doc":"- [4a9bcca3](https://github.com/appsignal/appsignal-elixir/commit/4a9bcca39e20370cc59560ba526618f5cb829ea4) patch - Add \"log_level\" config option. This new option allows you to select the type of messages\n  AppSignal's logger will log and up. The \"debug\" option will log all \"debug\", \"info\", \"warning\"\n  and \"error\" log messages. The default value is: \"info\"\n  \n  The allowed values are:\n  - error\n  - warning\n  - info\n  - debug\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Add `send_environment_metadata` config option to configure the environment metadata collection. For more information, see our [environment metadata docs](https://docs.appsignal.com/application/environment-metadata.html).\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Add the Erlang scheduler utilization to the metrics reported by the minutely probes. The metric is reported as a percentage value with the name `erlang_scheduler_utilization`, with the tag `type` set to `\"normal\"` and the tag `id` set to the ID of the scheduler in the Erlang VM.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - AppSignal for Elixir changelog","doc":"- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Bump agent to v-5b63505\n  \n  - Only filter parameters with the `filter_parameters` config option.\n  - Only filter session data with the `filter_session_data` config option.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Remove the `valid` key from the diagnose output. It's not a configuration option that\n  can be configured, but an internal state check if the configuration was considered valid.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Print the extension installation dependencies and flags in the diagnose report output.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Standardize diagnose validation failure message. Explain the diagnose request failed and why.\n- [f3bb8546](https://github.com/appsignal/appsignal-elixir/commit/f3bb854629c9e075056a68fcfe52072f96752dc0) patch - Bump agent to v-0db01c2\n  \n  - Add `log_level` config option in extension.\n  - Deprecate `debug` and `transaction_debug_mode` option in extension.","ref":"changelog.html#changed"},{"type":"extras","title":"Deprecated - AppSignal for Elixir changelog","doc":"- [4a9bcca3](https://github.com/appsignal/appsignal-elixir/commit/4a9bcca39e20370cc59560ba526618f5cb829ea4) patch - Deprecate \"debug\" and \"transaction_debug_mode\" config options in favor of the new \"log_level\"\n  config option.","ref":"changelog.html#deprecated"},{"type":"extras","title":"Removed - AppSignal for Elixir changelog","doc":"- [f40ead99](https://github.com/appsignal/appsignal-elixir/commit/f40ead993de3dc80a825ef821eb481f2eb3ecd66) patch - Remove the unused allocation tracking config option.","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - AppSignal for Elixir changelog","doc":"- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Fix a bug where setting the `:phoenix, :filter_parameters` configuration key to an allow-list of the form `{:keep, [keys]}` would apply this filtering to all sample data maps. The filtering is now only applied to the params sample data map.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Fix the Push API key validator request query params encoding.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - When the Push API key config option value is an empty string,\n  or a string with only whitespace characters, it is not considered valid anymore.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Transmit the path file modes in the diagnose report as an octal number. Previously it send values like `33188` and now it transmits `100644`, which is a bit more human readable.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Improve parameter and session data filtering options. Previously all filtering was done with one combined denylist of parameters and session data. Now `filter_parameters` only applies to parameters, and `filter_session_data` only applies to session data.\n- [10078177](https://github.com/appsignal/appsignal-elixir/commit/1007817782db6c59377eb7c61f24e884b200affb) patch - Fix the download of the agent during installation when Erlang is\n  using an OpenSSL version that does not support TLS 1.3, such as versions below OpenSSL 1.1.1.\n- [ad0b00f1](https://github.com/appsignal/appsignal-elixir/commit/ad0b00f1030d5b80910a9dd7c73b80512762f27d) patch - Suppress a warning emitted by Telemetry 1.0.0, regarding the performance penalty of using local functions as event handlers, by specifying the module of the captured function.","ref":"changelog.html#fixed"},{"type":"extras","title":"2.2.7 - AppSignal for Elixir changelog","doc":"- [f07f9cf9](https://github.com/appsignal/appsignal-elixir/commit/f07f9cf9c1d0d9696ee1a226630238dc75162fd7) patch - Bump agent to 09308fb.\n  \n  - Update sql_lexer dependency with support for reversed operators in queries.\n  - Add debug level logging to custom metrics in transaction_debug_mode.\n  - Add hostname config option to standalone agent.","ref":"changelog.html#2-2-7"},{"type":"extras","title":"2.2.6 - AppSignal for Elixir changelog","doc":"- [acb7295](https://github.com/appsignal/appsignal-elixir/commit/acb7295f1b876659f4ac8535c4c50592c77c336d) patch - Print String values in the diagnose report surrounded by quotes, and booleans as \"true\" and \"false\", rather than \"yes\" and \"no\". Makes it more clear that it's a value and not a label we print.\n- [e71792f](https://github.com/appsignal/appsignal-elixir/commit/e71792f9377a5ce98d338a63f2b0093a5ccee065) patch - Fix diagnose output rendering an additional empty line for the `appsignal.log` file. It appeared that only 9 lines were printed instead of the 10 expected lines.\n- [422cbd1](https://github.com/appsignal/appsignal-elixir/commit/422cbd128ecfc24ad6891cc39f889f1d1c531602) patch - Render the install report errors in the diagnose CLI output fewer times. A missing download and/or install report could sometimes be displayed up to two times, in total four errors.\n- [f7c0b1e](https://github.com/appsignal/appsignal-elixir/commit/f7c0b1e3f301e8eed72cadecdd9bf892c529173c) patch - Support mix task diagnose arguments. When an app is released with `mix release` CLI arguments cannot normally be passed to the diagnose task. Use the `eval` command pass along the CLI arguments as function arguments.\n  \n  ```\n  mix format\n  # Without arguments\n  bin/your_app eval ':appsignal_tasks.diagnose()'\n  # With arguments\n  bin/your_app eval ':appsignal_tasks.diagnose([\"--send-report\"])'\n  ```\n- [c51c065](https://github.com/appsignal/appsignal-elixir/commit/c51c065c71e08c4876b94680659b96062b5273b3) patch - Update diagnose output labels to be similar to our other language integrations.\n- [9d3e253](https://github.com/appsignal/appsignal-elixir/commit/9d3e25342cdf11ad8b6fb025209629552f816b1e) patch - Add new config option to enable/disable StatsD server in the AppSignal agent. This new config option is called `enable_statsd` and is set to `false` by default. If set to `true`, the AppSignal agent will start a StatsD server on port 8125 on the host.","ref":"changelog.html#2-2-6"},{"type":"extras","title":"2.2.5 - AppSignal for Elixir changelog","doc":"- [e7d676a9](https://github.com/appsignal/appsignal-elixir/commit/e7d676a9832192f745bb331f2382857226768e36) patch - Update SSL configuration for OTP 23 and newer to fix the Cloudfront mirror download during installation.\n- [7ccf75ce](https://github.com/appsignal/appsignal-elixir/commit/7ccf75cea16b634eca4140ed785508b82baa19b8) patch - Fix install result message to no longer show a success message when an installation failure occurred.","ref":"changelog.html#2-2-5"},{"type":"extras","title":"2.2.4 - AppSignal for Elixir changelog","doc":"- [787684bf](https://github.com/appsignal/appsignal-elixir/commit/787684bf61dfdfca65bbb4bc70706942302dd80e) patch - Installation report improved for download errors. Download errors are more descriptive in the installation result of the diagnose report.","ref":"changelog.html#2-2-4"},{"type":"extras","title":"2.2.3 - AppSignal for Elixir changelog","doc":"- [b89ab7bc](https://github.com/appsignal/appsignal-elixir/commit/b89ab7bc7958319e60c9ee1e7edf5664d8fc8973) patch - Bump agent to 7376537\n  \n  - Support JSON PostgreSQL operator in sql_lexer.\n  - Do not strip comments from SQL queries.","ref":"changelog.html#2-2-3"},{"type":"extras","title":"2.2.2 - AppSignal for Elixir changelog","doc":"- [c6772da3](https://github.com/appsignal/appsignal-elixir/commit/c6772da3dca036c020864303044aa4f265c6b18e) patch - Fix extension installer from cached source in `/tmp` directory. This would cause installation errors of the package if the AppSignal package was reinstalled again on a host that already installed it once.","ref":"changelog.html#2-2-2"},{"type":"extras","title":"2.2.1 - AppSignal for Elixir changelog","doc":"- [a7987f3](https://github.com/appsignal/appsignal-elixir/commit/a7987f31d110893e10255f4593b9137328245f34) patch - Add mirrors to download the agent","ref":"changelog.html#2-2-1"},{"type":"extras","title":"2.2.0 - AppSignal for Elixir changelog","doc":"- [1d7b7a3](https://github.com/appsignal/appsignal-elixir/commit/1d7b7a3f560321a2056126be1ebbb3715ac823b5) minor - Use underscores instead of slashes in spans created from decorators. This will change action naming from `Module.function/1` to `Module.function_1`.\n- [7927a3f](https://github.com/appsignal/appsignal-elixir/commit/7927a3fc6e2f3ce4f1ca150d2dd6123d08e40967) patch - Bump agent to v-0318770.\n  \n  - Improve Dokku platform detection. Do not disable host metrics on\n    Dokku.\n  - Report CPU steal metric.","ref":"changelog.html#2-2-0"},{"type":"extras","title":"2.1.15 - AppSignal for Elixir changelog","doc":"- [325c985](https://github.com/appsignal/appsignal-elixir/commit/325c98540407fe29d757c0438066ca265ce70502) patch - Add support for telemetry 1.0.0","ref":"changelog.html#2-1-15"},{"type":"extras","title":"2.1.14 - AppSignal for Elixir changelog","doc":"- [231abb13](https://github.com/appsignal/appsignal-elixir/commit/231abb135f962bd3fb8c18c781325bf04d07e9f5) patch - Bump agent to 0f40689\n  \n  - Add Apple Darwin ARM alias.\n  - Improve appsignal.h documentation.\n  - Improve transaction debug log for errors.\n  - Fix agent zombie/defunct issue on containers without process reaping.","ref":"changelog.html#2-1-14"},{"type":"extras","title":"2.1.13 - AppSignal for Elixir changelog","doc":"- [2531288d](https://github.com/appsignal/appsignal-elixir/commit/2531288dd6e8b5e76572b8d83045bbb4118fadfa) patch - Fix Apple ARM detection. It wasn't properly detected as an Apple ARM host because the installer did not account for an architecture String a without 32/64-bit indicator.","ref":"changelog.html#2-1-13"},{"type":"extras","title":"2.1.12 - AppSignal for Elixir changelog","doc":"- [0e2cd629](https://github.com/appsignal/appsignal-elixir/commit/0e2cd6290abf284672582c9ecaf033e764ad7165) patch - Only create root spans from transaction and channel action decorators, as they're meant to only be used when no span exists yet.","ref":"changelog.html#2-1-12"},{"type":"extras","title":"2.1.11 - AppSignal for Elixir changelog","doc":"- [4ba38f9](https://github.com/appsignal/appsignal-elixir/commit/4ba38f90cbc762114649c02ed01a5740381d184b) patch - Bump agent to v-891c6b0. Add experimental Apple Silicon M1 ARM64 build.","ref":"changelog.html#2-1-11"},{"type":"extras","title":"2.1.10 - AppSignal for Elixir changelog","doc":"- [523e229e](https://github.com/appsignal/appsignal-elixir/commit/523e229e7dee8ea76bfc46d43898f5a8667368ad) patch - Bump agent to version that is compatible with different error grouping\n  types.","ref":"changelog.html#2-1-10"},{"type":"extras","title":"2.1.9 - AppSignal for Elixir changelog","doc":"- [76a31400](https://github.com/appsignal/appsignal-elixir/commit/76a314002321bc9a2df00fff66b549c61262f691) patch - Add Linux ARM override value to diagnose report. This was omitted from the original implementation of the `APPSIGNAL_BUILD_FOR_LINUX_ARM` flag.\n- [07d1ea17](https://github.com/appsignal/appsignal-elixir/commit/07d1ea17cc76e3407ae7dc81da030c9362122eca) patch - Bump agent to c2024bf with appsignal-agent diagnose timing issue fix when reading the report and improved filtering for HTTP request transmission logs.","ref":"changelog.html#2-1-9"},{"type":"extras","title":"2.1.8 - AppSignal for Elixir changelog","doc":"- [b2c888dc](https://github.com/appsignal/appsignal-elixir/commit/b2c888dc3a0c18ccde5e496995204a2ca1854b57) patch - Update `APPSIGNAL_BUILD_FOR_MUSL` behavior to only listen to the values `1` and `true`. This way `APPSIGNAL_BUILD_FOR_MUSL=false` is not interpreted to install the musl build.\n- [f467daf9](https://github.com/appsignal/appsignal-elixir/commit/f467daf9f8da435139a6b5e0d232b17927c07675) patch - Add Linux ARM 64-bit experimental build, available behind a feature flag. To test this set the `APPSIGNAL_BUILD_FOR_LINUX_ARM` flag before compiling your apps: `export APPSIGNAL_BUILD_FOR_LINUX_ARM=1  `. Please be aware this is an experimental build. Please report any issue you may encounter at our [support email](mailto:support@appsignal.com).\n- [b8075176](https://github.com/appsignal/appsignal-elixir/commit/b8075176ed5fc4afac90ab2b788ba6397b41a814) patch - Use `MapSet`s for `Monitor`'s internal monitor list. As uniqueness is guaranteed (you can't monitor a particular pid more than once), MapSet is a better data structure to store this information, since all its operations are constant-time instead of linear-time.\n- Track `erlang_atoms` gauge in erlang probe. This reports the `atom_limit` and `atom_count` metrics. PR #651","ref":"changelog.html#2-1-8"},{"type":"extras","title":"2.1.7 - AppSignal for Elixir changelog","doc":"- Keep internal list of monitors in Appsignal.Monitor process. PR 648","ref":"changelog.html#2-1-7"},{"type":"extras","title":"2.1.6 - AppSignal for Elixir changelog","doc":"- Fix `Appsignal.logger` debug level issue on no config present. PR #644\n- Bump agent to d08ae6c. PR #645. Fix span API related issues with empty events\n  for error samples and missing incidents.","ref":"changelog.html#2-1-6"},{"type":"extras","title":"2.1.5 - AppSignal for Elixir changelog","doc":"- Add `Appsignal.Logger` to only log debug messages when the `:debug` configuration is turned on. PR #642","ref":"changelog.html#2-1-5"},{"type":"extras","title":"2.1.4 - AppSignal for Elixir changelog","doc":"- Ensure the `:request_headers` config returns an empty list by default. PR #637","ref":"changelog.html#2-1-4"},{"type":"extras","title":"2.1.3 - AppSignal for Elixir changelog","doc":"- Use pid from conn in Error.Backend if available. PR #631","ref":"changelog.html#2-1-3"},{"type":"extras","title":"2.1.2 - AppSignal for Elixir changelog","doc":"- Make sure Appsignal.se(nd|t)_error is properly delegated. PR #629","ref":"changelog.html#2-1-2"},{"type":"extras","title":"2.1.1 - AppSignal for Elixir changelog","doc":"- Probes.handle_info/2 handles non-exception errors. PR #626","ref":"changelog.html#2-1-1"},{"type":"extras","title":"2.1.0 - AppSignal for Elixir changelog","doc":"- Pass functions to set error  PR #622\n- Pass Elixir exceptions to `Appsignal.Instrumentation.se(t|nd)_error/2`. PR #620","ref":"changelog.html#2-1-0"},{"type":"extras","title":"2.0.8 - AppSignal for Elixir changelog","doc":"- Clear warnings. PR #623","ref":"changelog.html#2-0-8"},{"type":"extras","title":"2.0.7 - AppSignal for Elixir changelog","doc":"- Let set error use root span. PR (#611)\n- Bump agent to v-44e4d97\n  - Implement ignore namespaces for spans. PR #645","ref":"changelog.html#2-0-7"},{"type":"extras","title":"2.0.6 - AppSignal for Elixir changelog","doc":"- Monitor all registered spans. PR #608\n- Switch to reference-based child Span API, fixes memory leak when using\n  child spans. PR #607","ref":"changelog.html#2-0-6"},{"type":"extras","title":"2.0.5 - AppSignal for Elixir changelog","doc":"- Don't register query spans without parents. PR #600","ref":"changelog.html#2-0-5"},{"type":"extras","title":"2.0.4 - AppSignal for Elixir changelog","doc":"- Bump agent to v-c55fb2c\n  - Fix ignore actions and spans without names bugs. PR #639","ref":"changelog.html#2-0-4"},{"type":"extras","title":"2.0.3 - AppSignal for Elixir changelog","doc":"- Bump agent to v-f9d2b57\n  - Add error counts to map for spans. PR #638","ref":"changelog.html#2-0-3"},{"type":"extras","title":"2.0.2 - AppSignal for Elixir changelog","doc":"- Use \"channel\" namespace in channel_action decorator. PR #596","ref":"changelog.html#2-0-2"},{"type":"extras","title":"2.0.1 - AppSignal for Elixir changelog","doc":"- Ignore unhandled info, code_change and terminate in Error.Backend. PR #594\n- Explicitly ignore returns from Span functions. PR #593","ref":"changelog.html#2-0-1"},{"type":"extras","title":"2.0.0 - AppSignal for Elixir changelog","doc":"- Set categories from `transaction_event/3` decorator fallback. PR #583\n- Remove Plug and Phoenix fallbacks in favour of post-install message. PR #582\n- Bump agent to v-881e3b3\n  - Agent writes diagnose to file, extension reads from file. PR #628\n  - Ignore actions when creating span payload. PR #630\n  - Update Cargo.lock after bumping probes-rs and running cargo update. PR #633\n- Bump agent to v-5b16a75\n  - Fixed a version mismatch issue in the agent which caused no samples to be processed\n- Bump agent to v-38010f3\n  - Use Rust 1.46.0 and spawn agent without waiting for it. PR #618\n- Set category names in demo command\n  Commit dd5a4c019f403a5c55be0f4f07bda8d85385aef4\n- Add Repo configuration. PR #578\n- Link AppSignal config when config/config.exs does not exist. PR #577\n- Set category from Appsignal.Instrumentation.instrument/3\n  Commit  c8a789e9ff5dfe0d5a522448a923f94a1f54b63d\n- Add debug log lines on handler attachment\n  Commit 44f594dc6c4fa00b0ecb329aea16907cb106a67a\n  Commit 23a9cd0bf063e96c9b87ca2b2cf797ab96d4f96b\n  Commit a0ac8566f1d200152748b98f938ba78813767f9e\n- Bump agent to v-c8f8185. PR #575\n- Implement _set_span_namespace. PR #576\n- Tracer handles registry being down\n  Commit 86e433e42ebfd080d5a1f8450f9a29784ef2d4d9\n- Handle nil-spans in span.set_namespace/2\n  Commit d0f5d9d96890f0caaa80c58c7a34a343b722591e\n- Restore Appsignal.send_error/3 and Appsignal.set_error/3. PR #574\n- Remove unused module attributes from Appsignal module\n- Switch to span-based API\n- Reimplement error handling\n- Reimplement Ecto integration\n- Split out Plug integration into separate library\n- Split out Phoenix integration into separate library\n- Bump agent to v-a21a12a","ref":"changelog.html#2-0-0"},{"type":"extras","title":"1.13.5 - AppSignal for Elixir changelog","doc":"- Bump agent to v-20f7d0d\n  - Spawn agent without waiting for it. PR #618\n  - Agent writes diagnose to file, extension reads from file. PR #628","ref":"changelog.html#1-13-5"},{"type":"extras","title":"1.13.4 - AppSignal for Elixir changelog","doc":"- Bump agent to v-4548c88\n  - Fix issue with host metrics values being reported as \"Infinity\". PR #572","ref":"changelog.html#1-13-4"},{"type":"extras","title":"1.13.3 - AppSignal for Elixir changelog","doc":"- Add callback for `TransactionBehaviour.set_sample_data/2`. PR #560\n- Use tls 1.3 cipher suites on OTP 23. PR #571","ref":"changelog.html#1-13-3"},{"type":"extras","title":"1.13.2 - AppSignal for Elixir changelog","doc":"- Handle non-string-non-atom-non-iteger values in Transaction.to_s/1\n  Commit 772cb943b6d545942a50042a268d441973adab23","ref":"changelog.html#1-13-2"},{"type":"extras","title":"1.13.1 - AppSignal for Elixir changelog","doc":"- Use `__STACKTRACE__ /0` on Elixir >= 1.7. PR 559\n- Relax live_view dependency to allow versions over 0.9. PR #558\n- Bump agent to v-96b684b\n  - Check if queued payloads are for correct app and not expired","ref":"changelog.html#1-13-1"},{"type":"extras","title":"1.13.0 - AppSignal for Elixir changelog","doc":"- Add LiveView instrumentation helpers. PR #549\n- Fix typespec for Appsignal.Phoenix.Channel.channel_action/4. PR #553\n- Add record event callback to TransactionBehaviour. PR #555","ref":"changelog.html#1-13-0"},{"type":"extras","title":"1.12.1 - AppSignal for Elixir changelog","doc":"- EventHandler handles router_dispatch events with plug_opts #547","ref":"changelog.html#1-12-1"},{"type":"extras","title":"1.12.0 - AppSignal for Elixir changelog","doc":"- Add explicit error handling for Phoenix channels. PR #527\n- Add Phoenix Telemetry event handler to add Phoenix 1.5 instrumentation. PR #528 & #538\n\n  Before version Phoenix version 1.5. AppSignal’s Phoenix instrumentation\n  depended on data from the Phoenix instrumenter, and the installation\n  instructions included a step to attach AppSignal’s instrumenter to your\n  application in your app’s configuration:\n\n      config :appsignal_phoenix_example, AppsignalPhoenixExampleWeb.Endpoint,\n        #...\n        instrumenters: [Appsignal.Phoenix.Instrumenter]\n\n  From Phoenix 1.5 on, the old Phoenix instrumentation is deprecated and\n  removed in favor of the new Telemetry-based instrumentation. When upgrading\n  to Phoenix 1.5, you’ll see a warning during compilation when using the old\n  instrumenters:\n\n      [warn] :instrumenters configuration for\n      AppsignalPhoenixExampleWeb.Endpoint is deprecated and has no effect\n\n  To switch to the new instrumentation, make sure you're running version 1.12.0\n  of the AppSignal integration or higher.  Then, remove the instrumenters\n  configuration option from your endpoint configuration.  The new\n  instrumentation should appear automatically in your samples as an event named\n  call.phoenix_endpoint.","ref":"changelog.html#1-12-0"},{"type":"extras","title":"1.11.8 - AppSignal for Elixir changelog","doc":"- Reduce calls to pids_and_monitor_references/1 and :ets.match/1 #543. PR #543","ref":"changelog.html#1-11-8"},{"type":"extras","title":"1.11.7 - AppSignal for Elixir changelog","doc":"- Return the Ecto.LogEntry even if the transaction is nil. PR #542","ref":"changelog.html#1-11-7"},{"type":"extras","title":"1.11.6 - AppSignal for Elixir changelog","doc":"- Call pids_and_monitor_references/1 from TransactionRegistry. PR #541","ref":"changelog.html#1-11-6"},{"type":"extras","title":"1.11.5 - AppSignal for Elixir changelog","doc":"- Use a complete set of ssl_options for Hackney. PR #534","ref":"changelog.html#1-11-5"},{"type":"extras","title":"1.11.4 - AppSignal for Elixir changelog","doc":"- Add transaction_debug configuration option. PR #526\n- Bump agent to v-c348132\n  - Improve transmitter logging on timeout\n  - Improve queued payloads transmitter. Should prevent payloads being\n    sent multiple times.\n  - Add transaction debug mode\n  - Wrap Option in Mutex in TransactionInProgess","ref":"changelog.html#1-11-4"},{"type":"extras","title":"1.11.3 - AppSignal for Elixir changelog","doc":"- Transaction.set_action/2 returns the Transaction on failure. commit 16e5ecbc90aece993177da7e1b2486fa477e25e8\n- Don't match on :ok on Appsignal.Plug.finish_with_conn/2. commit ebc7dd968a9bbeff3447e8f84dab181205f976ed","ref":"changelog.html#1-11-3"},{"type":"extras","title":"1.11.2 - AppSignal for Elixir changelog","doc":"- Run receiver monitors in receiver process. PR #525.\n- Move action nil-check to `Appsignal.Transaction.set_action/2`. PR #523.","ref":"changelog.html#1-11-2"},{"type":"extras","title":"1.11.1 - AppSignal for Elixir changelog","doc":"- Don't match on return from `Transaction.complete/1`. PR #521","ref":"changelog.html#1-11-1"},{"type":"extras","title":"1.11.0 - AppSignal for Elixir changelog","doc":"- Convert time units for all Ecto callbacks. PR #481\n- Deactivate AppSignal when not active. PR #478\n- Fix FreeBSD compilation. PR #484\n- Extract ETS and Receiver logic from TransactionRegistry. PR #505\n- Add support for both Jason and Poison. PR #506\n- Add Erlang Run Queue length metric. PR #492\n- Filter structs in MapFilter. PR #507","ref":"changelog.html#1-11-0"},{"type":"extras","title":"1.10.13 - AppSignal for Elixir changelog","doc":"- OTP 22.1 hackney workaround for honor_cipher_order. PR #516\n- Bump agent to v-690f4b8 - commit 5245f919d975135d553a89b019c421e1fe27edd3\n  - Validate transmission_interval option.","ref":"changelog.html#1-10-13"},{"type":"extras","title":"1.10.12 - AppSignal for Elixir changelog","doc":"- Bump agent to v-e1c9363\n  - Better detect zombie/defunct processes on containers and consider the\n    processes dead. This should improve the appsignal-agent start behavior.\n  - Detect revision from Heroku dynos automatically when Dyno Metadata is\n    turned on.","ref":"changelog.html#1-10-12"},{"type":"extras","title":"1.10.11 - AppSignal for Elixir changelog","doc":"- Bump agent to v-a718022\n  - Fix container CPU runtime metrics.\n    See https://github.com/appsignal/probes-rs/pull/38 for more information.\n  - Improve host metrics calculations accuracy for counter metrics.\n    See https://github.com/appsignal/probes-rs/pull/40 for more information.\n  - Support Kernel 4.18+ format of /proc/diskstats file parsing.\n    See https://github.com/appsignal/probes-rs/pull/39 for more information.","ref":"changelog.html#1-10-11"},{"type":"extras","title":"1.10.10 - AppSignal for Elixir changelog","doc":"- Restore get_filter_(parameters|session_data) to patch backwards compatibility. PR #500","ref":"changelog.html#1-10-10"},{"type":"extras","title":"1.10.9 - AppSignal for Elixir changelog","doc":"- Support parameter filtering with {:keep, params}. PR #499","ref":"changelog.html#1-10-9"},{"type":"extras","title":"1.10.8 - AppSignal for Elixir changelog","doc":"- Handle non-maps in Config.active?/0. PR #495\n- Use Phoenix >= 1.2.0 and < 1.4.0 on Elixir 1.3. PR #496","ref":"changelog.html#1-10-8"},{"type":"extras","title":"1.10.7 - AppSignal for Elixir changelog","doc":"- Fix musl detection on installation. PR #493","ref":"changelog.html#1-10-7"},{"type":"extras","title":"1.10.6 - AppSignal for Elixir changelog","doc":"- Use the bundled certificate and ciphers when downloading agent (#491)\n- Explicitly set ciphers in hackney https requests (#489)\n- Remove log statements from TransactionRegisty (#490)\n- Improve ldd version error handling (#487)","ref":"changelog.html#1-10-6"},{"type":"extras","title":"1.10.5 - AppSignal for Elixir changelog","doc":"- Remove explicit ignore check in TransactionRegistry. PR #480\n- Handle errors in Mix.Appsignal.Helper.uid/0. PR #479","ref":"changelog.html#1-10-5"},{"type":"extras","title":"1.10.4 - AppSignal for Elixir changelog","doc":"- Handle atom keys in MapFilter.filter_values/2. PR #475","ref":"changelog.html#1-10-4"},{"type":"extras","title":"1.10.3 - AppSignal for Elixir changelog","doc":"- Track memory metrics of the current process. PR #473","ref":"changelog.html#1-10-3"},{"type":"extras","title":"1.10.2 - AppSignal for Elixir changelog","doc":"- Fix memory leak in custom metrics key names.\n  Commit 91c65e51cc949e66b3f504444f3570858a598352","ref":"changelog.html#1-10-2"},{"type":"extras","title":"1.10.1 - AppSignal for Elixir changelog","doc":"* Add enable_minutely_probes config option. PR #470\n* Tag hostnames in ErlangProbe. PR #469\n* Don't use fetch_env!/2 in ErlangProbe. PR #471","ref":"changelog.html#1-10-1"},{"type":"extras","title":"1.10.0 - AppSignal for Elixir changelog","doc":"* Store extension installation details in report. PR #433\n* Fail AppSignal extension installation on warnings\n  Commit 7b17a0b86f87ea7097315d1247ccd52c78be8e97\n* Rescue `make` command errors\n  Commit 69efc629eaa0a3f3a3e2d8c3871f3c7bba86c151\n* Add response status codes to Plug samples. PR #453\n* Use :logger instead of :error_logger on OTP >= 21. PR #454\n* Allow Appsignal.Plug.call/2 to be overridden. PR #464\n* Use proxy from system environment when downloading agent. PR #458\n* Bump agent to 4a275d3\n  Commit 0635e043d4b299d7ec838f89ca4d36c3ed3792ce\n  - Support container CPU host metrics.\n  - Support StatsD server in agent.\n  - Fix samples being reported for multiple namespaces.\n  - Report memory and swap usage in percent using the memory_usage and\n    swap_usage metrics.\n* Add Erlang Probe. PR #466\n* Minutely Probing for Custom Metrics. PR #461","ref":"changelog.html#1-10-0"},{"type":"extras","title":"1.9.4 - AppSignal for Elixir changelog","doc":"- Update Ecto integration to support both Telemetry 0.3.x and 0.4.x. PR #459","ref":"changelog.html#1-9-4"},{"type":"extras","title":"1.9.3 - AppSignal for Elixir changelog","doc":"- Support send_params option. PR #456","ref":"changelog.html#1-9-3"},{"type":"extras","title":"1.9.2 - AppSignal for Elixir changelog","doc":"- Fix multi user permission issue for agent directories and files.\n  Commit fdd650097b702a8aa60ee90ee93ad4e3e3365d81","ref":"changelog.html#1-9-2"},{"type":"extras","title":"1.9.1 - AppSignal for Elixir changelog","doc":"* Block on ignoring PIDs in TransactionRegistry. PR #448","ref":"changelog.html#1-9-1"},{"type":"extras","title":"1.9.0 - AppSignal for Elixir changelog","doc":"* Add missing host OS field to diagnose report. PR #418\n* Link back to AppSignal diagnose report page. PR #420\n* Add `Error.metadata/2` to extract error metadata. PR #423\n* Format values printed in the diagnose. PR #426\n* Update diagnose paths section. PR #427\n* Add unified ErrorHandler. PR #425\n* Fix appsignal.log default path. PR #429\n* Support container memory host metrics better. PR #431\n* Change files_world_accessible permissions to not make files executable. PR #431\n* Make agent debug logging for disk IO metrics more robust. PR #431","ref":"changelog.html#1-9-0"},{"type":"extras","title":"1.8.2 - AppSignal for Elixir changelog","doc":"* Add Appsignal.Ecto.handle_event/4 to support Ecto 3. PR #416\n* Add diagnose command --[no-]send-report option. PR #414\n* Group extension and agent tests in diagnose output. PR #413\n* Add new agent & extension diagnose report keys. PR #412\n* Pretty print lists in diagnose output. PR #408\n* Add :poison to :applications. PR #404\n* Add :hackney to :applications. PR #403\n* Allow Appsignal.send_error/1-7 to be called without a stack trace. PR #400\n* Use `Mix.shell.info` instead of `Logger.info` in mix helpers. PR #399","ref":"changelog.html#1-8-2"},{"type":"extras","title":"1.8.1 - AppSignal for Elixir changelog","doc":"* Fix linking issues on multi-stage build setups. PR #406","ref":"changelog.html#1-8-1"},{"type":"extras","title":"1.8.0 - AppSignal for Elixir changelog","doc":"* Add working_directory_path config option. PR #363\n* Use doubles values in custom metrics functions. PR #384\n* Support Elixir 1.7. PR #386","ref":"changelog.html#1-8-0"},{"type":"extras","title":"1.7.2 - AppSignal for Elixir changelog","doc":"* Ensure ca_file_path is written to agent env. PR #381\n* Use gmake over make when gmake executable exists. PR #382","ref":"changelog.html#1-7-2"},{"type":"extras","title":"1.7.1 - AppSignal for Elixir changelog","doc":"* Fix absolute path to CA certificate file. PR #380","ref":"changelog.html#1-7-1"},{"type":"extras","title":"1.7.0 - AppSignal for Elixir changelog","doc":"* Bundle CA certificate. PR #364\n* Add Appsignal.Transaction.set_namespace/1-2. PR #361\n* Use :hackney instead of cURL to download agent. PR #359","ref":"changelog.html#1-7-0"},{"type":"extras","title":"1.6.7 - AppSignal for Elixir changelog","doc":"* Revert container memory metrics fixes. PR #370\n* Fix _APP_REVISION read logic in extension. PR #370\n* Fix _APPSIGNAL_PROCESS_NAME read logic in extension. PR #370","ref":"changelog.html#1-6-7"},{"type":"extras","title":"1.6.6 - AppSignal for Elixir changelog","doc":"* Add container memory metrics fixes.\n* Use local agent environment instead of system environment. PR #368","ref":"changelog.html#1-6-6"},{"type":"extras","title":"1.6.5 - AppSignal for Elixir changelog","doc":"* Allow calling `Transaction.register/1` and `Transaction.complete/1` when the Registry is not alive. PR #356","ref":"changelog.html#1-6-5"},{"type":"extras","title":"1.6.4 - AppSignal for Elixir changelog","doc":"* Overwrite message for Phoenix.ActionClauseError. PR #355","ref":"changelog.html#1-6-4"},{"type":"extras","title":"1.6.3 - AppSignal for Elixir changelog","doc":"* Remove script_name, query_string and peer from Plug.extract_sample_data/1. PR #351","ref":"changelog.html#1-6-3"},{"type":"extras","title":"1.6.2 - AppSignal for Elixir changelog","doc":"* Merge instead of ignore Phoenix's :filter_parameters if also configured in AppSignal. PR #349","ref":"changelog.html#1-6-2"},{"type":"extras","title":"1.6.1 - AppSignal for Elixir changelog","doc":"* Remove request_headers warning and use sane default. PR #346\n* Fix metrics format for internal agent metrics. PR #347","ref":"changelog.html#1-6-1"},{"type":"extras","title":"1.6.0 - AppSignal for Elixir changelog","doc":"* Explicit header whitelist in configuration (#336)\n* Add filter_session_data config option (#343)\n* Log with :info level instead of :warn when AppSignal is disabled (#340)\n* Remove default hostname (#339)\n* Remove filter_parameters config for extension (#337)\n* Demonitor processes when the transaction completes (#333)\n* Hard-remove transactions from the Registry (#332)\n* Accept tags for (custom) metrics (#331)\n* Don't register Transactions created by `Appsignal.send_error/7`  (#330)\n* Remove transaction when calling `Transaction.complete` (#329)\n* Add :request_headers and APPSIGNAL_REQUEST_HEADERS configuration (#327)\n* Filter arguments in backtraces (#326)\n* Relax :httpoison dependency to allow ~> 1.0 (#322)","ref":"changelog.html#1-6-0"},{"type":"extras","title":"1.5.0 - AppSignal for Elixir changelog","doc":"* Add agent.exs file to package in mix.exs (#323)\n* Restore :revision config (#315)\n* Underscored environment variables are always overwritten (#316)\n* Move compilation helper functions to mix_helpers.exs (#314)\n* Use \"unknown\" as action for Plug-only transactions, set action before `call/2` (#311)\n* Bump agent to ca32965 (#310, #315)\n  - Underscore `_APP_REVISION` environment variable.\n  - Unset revision config option when the APP_REVISION environment\n    variable only contains an empty string.\n  - Fix locking issue on diagnose mode run\n  - Increase stored length of error messages","ref":"changelog.html#1-5-0"},{"type":"extras","title":"1.4.10 - AppSignal for Elixir changelog","doc":"* Fix POST parameters in errors, take the Plug.Conn from Plug.Conn.WrapperErrors (#309)","ref":"changelog.html#1-4-10"},{"type":"extras","title":"1.4.9 - AppSignal for Elixir changelog","doc":"* Add x-real-ip to request header whitelist (#308)\n* ErrorHandler doesn't cause warnings for noise over handle_info (#304)","ref":"changelog.html#1-4-9"},{"type":"extras","title":"1.4.8 - AppSignal for Elixir changelog","doc":"* Fix transaction metadata for send_error (#303)\n* Use Application.load/1 in diagnose task (#297)\n* Fix DataEncoder.encode error (#293)\n* Update agent to fix locking issue in diagnose (#300)","ref":"changelog.html#1-4-8"},{"type":"extras","title":"1.4.7 - AppSignal for Elixir changelog","doc":"* Fix compile errors on Elixir 1.6 (#298)","ref":"changelog.html#1-4-7"},{"type":"extras","title":"1.4.6 - AppSignal for Elixir changelog","doc":"* Wrap WrapperError clause in Appsignal.plug? (#291)\n* Don't use Plug.ErrorHandler.__catch__/4 in Appsignal.Plug (#287)","ref":"changelog.html#1-4-6"},{"type":"extras","title":"1.4.5 - AppSignal for Elixir changelog","doc":"* Ensure the appsignal application is started when running diagnose (#286)","ref":"changelog.html#1-4-5"},{"type":"extras","title":"1.4.4 - AppSignal for Elixir changelog","doc":"* ErrorHandler unwraps Plug.Conn.WrapperError (#281)\n* Fetch request_id in Appsignal.Plug.extract_meta_data/1 (#283)","ref":"changelog.html#1-4-4"},{"type":"extras","title":"1.4.3 - AppSignal for Elixir changelog","doc":"* Fix dialyzer linting violations. (#271)\n* Fix logger error on failed installation. (#275)\n* Reuse Appsignal.agent module by unloading it after use in `mix.exs`. (#277)","ref":"changelog.html#1-4-3"},{"type":"extras","title":"1.4.2 - AppSignal for Elixir changelog","doc":"* Change log level from info to debug for value comparing failures.\n  Commit 76fafebba5e37cfd2c303c286271f4616cf63bd3\n* Collect free memory host metric.\n  Commit 76fafebba5e37cfd2c303c286271f4616cf63bd3","ref":"changelog.html#1-4-2"},{"type":"extras","title":"1.4.1 - AppSignal for Elixir changelog","doc":"* Use musl build for older systems (#274)","ref":"changelog.html#1-4-1"},{"type":"extras","title":"1.4.0 - AppSignal for Elixir changelog","doc":"* Add separate GNU linux build. PR #265 and\n  Commit b9546cae01cd89d597586ad6c7dc4b5213fe2fca\n* Add separate FreeBSD build\n  Commit b9546cae01cd89d597586ad6c7dc4b5213fe2fca\n* Auto restart agent when none is running\n  Commit b9546cae01cd89d597586ad6c7dc4b5213fe2fca","ref":"changelog.html#1-4-0"},{"type":"extras","title":"1.3.6 - AppSignal for Elixir changelog","doc":"* Fix crashes when using a transaction from multiple processes in an unsupported way.\n  Commit b9546cae01cd89d597586ad6c7dc4b5213fe2fca\n* Allow string values in atom config fields (#269)","ref":"changelog.html#1-3-6"},{"type":"extras","title":"1.3.5 - AppSignal for Elixir changelog","doc":"* Allow multiple calls to `send_error` in one Transaction (#260)","ref":"changelog.html#1-3-5"},{"type":"extras","title":"1.3.4 - AppSignal for Elixir changelog","doc":"* Allow configuration of permissions of working directory. (#246)\n* Fix locking bug that delayed extension shutdown.\n  Commit 1953b2abced8c477af3eb973cc71b98c20761b51\n* Log extension start with app revision if present\n  Commit 1953b2abced8c477af3eb973cc71b98c20761b51","ref":"changelog.html#1-3-4"},{"type":"extras","title":"1.3.3 - AppSignal for Elixir changelog","doc":"* No channel payloads in the channel_action decorator (#255)\n* Add architecture for elixir:alpine Docker image (#256)","ref":"changelog.html#1-3-3"},{"type":"extras","title":"1.3.2 - AppSignal for Elixir changelog","doc":"* Don't crash with unbound channel payloads (#253)","ref":"changelog.html#1-3-2"},{"type":"extras","title":"1.3.1 - AppSignal for Elixir changelog","doc":"* Appsignal.Phoenix.Channel.channel_action/5 includes channel parameters (#251)\n* Add files world accessible option to config (#246)","ref":"changelog.html#1-3-1"},{"type":"extras","title":"1.3.0 - AppSignal for Elixir changelog","doc":"* Plug support without Phoenix\n* Transaction.set_request_metadata sets path and method\n* Add arch mapping for 32bit linux\n* Check if curl is installed before calling it\n* Add ignore_namespaces option\n* Whitelist request headers","ref":"changelog.html#1-3-0"},{"type":"extras","title":"1.2.3 - AppSignal for Elixir changelog","doc":"* Add architecture mappings for 32bit systems. (#229)","ref":"changelog.html#1-2-3"},{"type":"extras","title":"1.2.2 - AppSignal for Elixir changelog","doc":"* Better backtraces for linked processes (#207)\n* Backtrace.format_stacktrace handles lists of binaries (#214)","ref":"changelog.html#1-2-2"},{"type":"extras","title":"1.2.1 - AppSignal for Elixir changelog","doc":"* Allow nil transaction in instrumentation (#198)\n* ErrorHandler handles errors in tuples (#201)\n* Set `env: Mix.env` in generated config.exs (#203)\n* Improve registry lookup performance (#205)","ref":"changelog.html#1-2-1"},{"type":"extras","title":"1.2.0 - AppSignal for Elixir changelog","doc":"* Catch and handle errors in the Plug using Plug.ErrorHandler instead of\n  in Appsignal.ErrorHandler (#187 & #193)","ref":"changelog.html#1-2-0"},{"type":"extras","title":"1.1.1 - AppSignal for Elixir changelog","doc":"* Fix unpacking agent tar as root (#179)\n* Add Instrumentation.Helpers.instrument/3\n* Add Appsignal.Backtrace, deprecate ErrorHandler.format_stack/1","ref":"changelog.html#1-1-1"},{"type":"extras","title":"1.1.0 - AppSignal for Elixir changelog","doc":"* Depend on Phoenix >= 1.2.0 instead of ~> 1.2.0 (#167)\n* Reload the config in a separate process (#166)\n* Add action names to exceptions (#162)","ref":"changelog.html#1-1-0"},{"type":"extras","title":"1.0.4 - AppSignal for Elixir changelog","doc":"* Fix propagation of transaction decorator return value (#164)","ref":"changelog.html#1-0-4"},{"type":"extras","title":"1.0.3 - AppSignal for Elixir changelog","doc":"* Force the agent to run in diagnostics mode even if the app's config doesn't\n  have AppSignal marked as active. (#132 and #160)\n* Remove duplicate config file linking output in installer (#159)\n* Upon install deactivate test env if available rather than activate any other\n  env (#159)\n* Print missing APPSIGNAL_APP_ENV env var in installation instructions. (#161)","ref":"changelog.html#1-0-3"},{"type":"extras","title":"1.0.2 - AppSignal for Elixir changelog","doc":"* Remove extra comma from generated config/appsignal.exs (#158)","ref":"changelog.html#1-0-2"},{"type":"extras","title":"1.0.1 - AppSignal for Elixir changelog","doc":"* Remove (confusing revision logic) (#154)","ref":"changelog.html#1-0-1"},{"type":"extras","title":"1.0.0 - AppSignal for Elixir changelog","doc":"* Bump to 1.0.0 🎉","ref":"changelog.html#1-0-0"},{"type":"extras","title":"0.13.0 - AppSignal for Elixir changelog","doc":"* Send demo samples on install (#136)\n* Make mix tasks available in releases (#146)\n* Rename Phoenix framework event names (#148)\n* Open and close Transactions in Appsignal.Phoenix.Plug.call/2 (#131)","ref":"changelog.html#0-13-0"},{"type":"extras","title":"0.12.3 - AppSignal for Elixir changelog","doc":"* Move package version to a module attribute (#143)","ref":"changelog.html#0-12-3"},{"type":"extras","title":"0.12.2 - AppSignal for Elixir changelog","doc":"* Bump agent to 5464697\n* Check agent version in Mix.Appsignal.Helper.ensure_downloaded/1 (#141)","ref":"changelog.html#0-12-2"},{"type":"extras","title":"0.12.1 - AppSignal for Elixir changelog","doc":"* Upgrade HTTPoison and allow more versions","ref":"changelog.html#0-12-1"},{"type":"extras","title":"0.12.0 - AppSignal for Elixir changelog","doc":"* Add mix appsignal.diagnose task (#81)\n* Auto activate when push_api_key in env, not always (#89)\n* Bump agent to f81fe90\n* Implement running_in_container detection.\n* Fix DNS issue with musl and resolv.conf using \"search\" on the first line of configuration.\n* Use agent.ex instead of agent.json, drop Poison dependency (#115)\n* DataEncoder encodes bignums as strings (#88)\n* Remove automatic :running_in_container setting (moved to agent)","ref":"changelog.html#0-12-0"},{"type":"extras","title":"0.11.6 - AppSignal for Elixir changelog","doc":"* Send body->data instead of body to appsignal_finish_event","ref":"changelog.html#0-11-6"},{"type":"extras","title":"0.11.5 - AppSignal for Elixir changelog","doc":"* Bump agent to version with extra null pointer protection","ref":"changelog.html#0-11-5"},{"type":"extras","title":"0.11.4 - AppSignal for Elixir changelog","doc":"* Bump agent (360f06b)","ref":"changelog.html#0-11-4"},{"type":"extras","title":"0.11.3 - AppSignal for Elixir changelog","doc":"* Update musl version to fix DNS search issue (a8e6f23)","ref":"changelog.html#0-11-3"},{"type":"extras","title":"0.11.2 - AppSignal for Elixir changelog","doc":"* Add support for non-strings as map values in DataEncoder.encode/1 (#83)","ref":"changelog.html#0-11-2"},{"type":"extras","title":"0.11.1 - AppSignal for Elixir changelog","doc":"* Add phoenix as optional dependency to :prod (#80)\n* Add the module name to the transaction action while using decorators (#79)","ref":"changelog.html#0-11-1"},{"type":"extras","title":"0.11.0 - AppSignal for Elixir changelog","doc":"* Re-initialize Appsignal's config after a hot code upgrade. (#71)\n* Send all request headers (#75)\n* Add ErrorHandler.normalize_reason (#78)\n* Elixir 1.4 compatibility\n* Add fix for grabbing filter_parameters from Phoenix (#73)\n* Add Alpine linux (#77)\n* Add appsignal.demo mix task (#69)\n* Drop Phoenix dependency #61","ref":"changelog.html#0-11-0"},{"type":"extras","title":"0.10.0 - AppSignal for Elixir changelog","doc":"* Check Appsignal.started?/1 in TransactionRegistry.lookup/2 (#54)\n* Various configuration fixes (#55)\n* Use APPSIGNAL_APP_ENV instead of APPSIGNAL_ENVIRONMENT (#56)\n* The agent logs to STDOUT on Heroku (#60)\n* Add a transcation decorator (#62)\n* Update agent to 5f0c552 (#64)\n* Enable host metrics by default (#66)\n* DataEncoder.encode/2 handles tuples (#68)\n* Registry.register/1 returns nil if Appsignal is not started (#70)\n* Appsignal.Transaction.set_error/4 handles unformatted stacktraces (#72)\n* Fix missing paren warnings in Elixir 1.4 (#59)\n* Add support to refs and pids inside payloads (#57)\n* Add centos/redhat support for agent installation (#48)","ref":"changelog.html#0-10-0"},{"type":"extras","title":"0.9.2 - AppSignal for Elixir changelog","doc":"* Fix Makefile for spaces in path names\n* Set APPSIGNAL_IGNORE_ACTIONS from config (#41)\n* Send metadata in Appsignal.ErrorHandler.submit_transaction/6 (#40)\n* Add a section suggesting active: false in test env (#35)","ref":"changelog.html#0-9-2"},{"type":"extras","title":"0.9.1 - AppSignal for Elixir changelog","doc":"* Appsignal.Helpers has been moved to Appsignal.Instrumentation.Helpers","ref":"changelog.html#0-9-1"},{"type":"extras","title":"0.9.0 - AppSignal for Elixir changelog","doc":"* Remove instrumentation macros, switch to decorators\n* Update channel decorators documentation\n* Documentation on instrumentation decorators\n* Let Appsignal.{set_gauge, add_distribution_value} accept integers (#31)\n* Implement Appsignal.send_error (#29)\n* Add documentation for filtered parameters (#28)\n* Appsignal.Utils.ParamsEncoder.preprocess/1 handles structs (#30)","ref":"changelog.html#0-9-0"},{"type":"extras","title":"0.8.0 - AppSignal for Elixir changelog","doc":"* Experimental support for channels\n* Add instrument_def macro for defining a single instrumented function\n* Document that we are using a NIF and how it is used\n* Simplified transaction functions no longer raise\n* Don't warn about missing config when running tests\n* remember original stacktrace in phoenix endpoint (#26)","ref":"changelog.html#0-8-0"},{"type":"extras","title":"0.7.0 - AppSignal for Elixir changelog","doc":"* Allow Phoenix filter parameters and/or OS env variable to be used\n* Send Phoenix session information\n* Simplify Transaction API: Default to the current process transaction\n* Add Transaction.filter_values/2\n* Transaction.set_request_metadata/2 filters parameters\n* Fix host metrics config key in GettingStarted","ref":"changelog.html#0-7-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}